C&TRAD3D
C **********************************************************************
C     Version 11061987       Programm TRADIKON-3D      Rev. 22/02/2006 *
C **********************************************************************
C                                                                      *
C                             -----------                              *
C                             TRADIKON-3D                              *
C                             -----------                              *
C                                                                      *
C        ein  stroemungsgekoppeltes,  dreidimensionales  finite        *
C        Differenzen Modell zur Berechnung des Waermetransports        *
C        durch Diffusion und Konvektion in gepannten/ungespann-        *
C        ten, anisotropen, heterogenen  Porengrundwasserleitern        *
C                                                                      *
C              Dirk R. Brehm                                           *
C              c/o BGU Dr. Brehm & Grnz GbR                           *
C              Technologiezentrum Bielefeld                            *
C              Meisenstrae 96                                         *
C              D-33 607 Bielefeld                                      *
C              FON:  +49 (521) 2997-250                                *
C              FAX:  +49 (521) 2997-253                                * 
C              http://www.bgu-geoservice.de                            *
C              dirk.brehm@bgu-geoservice.de                            *
C                                                                      *
C **********************************************************************
C
      PROGRAM TRAD3D
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      IMPLICIT DOUBLE PRECISION (E)
      DOUBLE PRECISION T,T0,STMP
      DOUBLE PRECISION UU,AA,BB,CC,DD
      CHARACTER FLAG*4,UFLS*4,TITEL*80
      CHARACTER FORMOU*30,FORTXT*48
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION UU(IMAX),AA(IMAX),BB(IMAX),CC(IMAX),DD(IMAX)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      DIMENSION FORMOU(8),FORTXT(8)
      COMMON /EKAL/EALT,EANF,ESUM
      COMMON /ENER/SC,SP,FRO
      COMMON /FORM/FORMOU,FORTXT
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IADI/UU,AA,BB,CC,DD
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INCB/INDX,INDY,INDZ,IADD,JADD,KADD
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /INF5/IVIS,IWRO
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /ISOP/IXISO,IYISO,IZISO,ISO1,IMSBIN
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PAR4/DTW,DTW2,DWAN,DTWL(3)
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /WPOT/H,H0
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
C
      EALT   =  0.
      EANF   =  0.
      IAN    = -1
      IEINS  =  0
      IEN1   =  1
      ISO1   =  0
      IUNIT  =  1
      IZAEHL =  0
      IDZTST =  0 
      IZUSD  =  0
      LUMW   =  0
      NIT    =  0
      NPROF  =  1
      RZEIT  =  0
      SUMSEK =  0.
      ZZZZ   =  1E30
      ZIGNO  = -99.9
C
C *** Subroutine INFORM Einlesen des Problemtitels, Timesteps etc. *****
C
      CALL INFORM
C
      IF (INPOP.GT.0) CALL DATEIN

C
C *** Subroutine TIMER Zeitabfrage mit Lahey-Compiler ******************
C
C     CALL TIMER(IZZZZ1)
C
C *** Subroutine GETTIM Zeitabfrage mit Compaq-Compiler ****************
C
	CALL GETTIM (IHr, IMin, ISec, I100th)
	IZZZZ1 =  (IHr * 3600 + IMin * 60 + ISec) * 100 + I100th
C
C *** Subroutine KURZIN Einlesen der Daten  - kurzer Input *************
C
      IF (INPOP.EQ.0) THEN
         CALL KURZIN
C
C *** Subroutine UMWAND Umwandeln der Zusatzinformationen **************
C
         IF (LUMW.GE.1) THEN
            DO 40 L = 1, LUMW
            CALL UMWAND (L,IAN)
   40       CONTINUE
         END IF
      END IF
C
C *** Subroutine ZUSDAT Einlesen zusaetzlicher, zeitabhaengiger Daten **
C
      IF (IDATOP.EQ.1) CALL ZUSDAT (IEINS)
C
C *** Subroutine WARMIN liest das Ergebnis der vorherigen Simulation ***
C
      IF (IWARMS.EQ.1) CALL WARMIN
C
C *** Subroutine KOPIER Kopieren der T oder H-Werte in ein anderes Feld
C
      IF (IGWF.LE.1) CALL KOPIER (1)
      IF (IGWF.GE.1) CALL KOPIER (2)
C
C *** Subroutine VDRUCK Drucken des Grundwasserfliessgeschwindigkeiten *
C
      IF (IDIF.EQ.1.AND.IGWF.EQ.0) CALL VDRUCK
C
C *** Subroutine INFINT Berechnung der Interface-Wichtungsfaktoren *****
C
      CALL INFINT
C
C *** Subroutine DATAUS Ausdrucken der Eingangsdaten *******************
C
      IF (IAUSOP.EQ.3.AND.IGWF.LE.2) CALL DATAUS
C
C *** Subroutine TAUPKT Gefrierpunktberechnung von Wasser **************
C
      IF (IGWF.LE.1.AND.IFROST.LT.3) CALL TAUPKT (STMP,ZKOR,1,1)
C
C *** Subroutine DZTEST Ueberpruefung der Zeitschrittlaenge ************
C
      IF (IDATOP.EQ.1.AND.IGWF.LE.1.AND.IDZTST.NE.0) THEN
         CALL DZTEST (LISDAT)
         IEIN = IZEIT
      END IF
      IF (IDATOP.EQ.0.AND.IGWF.LE.1.AND.IDZTST.NE.0) CALL DZTEST (IEIN)
C
C *** Subroutine DKTEST Ueberpruefung der Diskretisierungsvorschriften *
C
      IF (IDIF.EQ.1.AND.IGWF.EQ.0.AND.IDSTOP.NE.0) CALL DKTEST
C
C *** Subroutine FLUSFL Festlegung der Flowflags ***********************
C
      IF (IDIF.EQ.1.AND.IAUSOP.EQ.2.AND.IGWF.LE.1) THEN
         CALL FLUSFL (1,1,1,NX,NY,NZ)
      END IF    
C
C *** Subroutine PROFIL Drucken der Eingangsdaten in Profilschnitten ***
C
      IF (IAUSOP.EQ.2.AND.IGWF.LE.1) THEN
         CALL PROFIL (CPG,IFLAG,NPROF)
         CALL PROFIL (WLKG,IFLAG,NPROF)
         CALL PROFIL (RHOG,IFLAG,NPROF)
         CALL PROFIL (PHIG,IFLAG,NPROF)
         CALL PROFIL (PHIN,IFLAG,NPROF)
         CALL PROFIL (SC,IFLAG,NPROF)
         CALL PROFIL (SC,IFLAG,NPROF)
         CALL PROFIL (SC,IFLUS,NPROF)
      END IF
C
C *** Subroutine TMPDRU Drucken der berechneten Temperaturprofile ******
C
      IF (IGWF.LE.1) CALL TMPDRU
      IF (IGWF.GE.1) CALL PIEDRU
C
C *** falls das Stroemungsfeld als konstant angenommen wird ... ********
C
      IF (IGWF.EQ.0) THEN
C
C *** Subroutine AUFNUL Initialisieren der Koeffizienten - Felder ******
C
         CALL AUFNUL
C
C *** Subroutine KOEFFT Berechnung der Nachbarkoeffizienten fuer T *****
C
         CALL KOEFFT (1,1,1,NX,NY,NZ)
C
C *** Subroutine QKOEFT Berechnung der Quelltermkoeffizienten **********
C
         CALL QKOEFT
C
C *** Subroutine ENERGI Berechnung der Waermeenergie in den Zellen *****
C
         IMAL = IDRU
         IF (IENER.EQ.1) THEN
            CALL ENERGI
C
C *** Subroutine WFLUSS Berechnung des Waermeflusses zum Waermetauscher 
C
            CALL WFLUSS (IMAL)
         END IF
C
      END IF
      IZYKL = IZEIT / IEIN
      IAN = 1
C
      IF (IGWF.EQ.2) THEN
         CALL AUFNUL
         CALL KOEFFH
         CALL QKOEFH
      END IF
C
      DO 10 LOOP1 = 1, IZYKL
      DO 20 LOOP2 = 1, IEIN
C
C *** Subroutine OBSDAT Temperaturen auf sequentiellen File schreiben **
C
      IF (IOBS.GT.0) CALL OBSDAT
C
	CALL GETTIM (IHr, IMin, ISec, I100th)
	IZZZZ2 =  (IHr * 3600 + IMin * 60 + ISec) * 100 + I100th
      IF (IZZZZ2.GE.IZZZZ1) THEN
         RZEIT = RZEIT + (IZZZZ2-IZZZZ1)/100./60.
      ELSE
         RZEIT = RZEIT + (24*3600*100-IZZZZ1+IZZZZ2)/100./60.
      END IF
      IZZZZ1 = IZZZZ2
C
      IZAEHL = IZAEHL + 1
      IF (IDATOP.EQ.1.AND.IZUSD.EQ.LISDAT) THEN
         CALL ZUSDAT (IEINS)
         IZUSD = 0
         IF (IGWF.EQ.2) THEN
            CALL AUFNUL
            CALL KOEFFH
            CALL QKOEFH
         END IF
         IF (IGWF.EQ.0) THEN
            CALL AUFNUL
            CALL KOEFFT (1,1,1,NX,NY,NZ)
            CALL QKOEFT
         END IF
      END IF
      IF (IDATOP.EQ.1) IZUSD = IZUSD + 1
C
C *** falls das Stroemungsfeld berechnet werden soll ... ***************
C
      IF (IGWF.EQ.1) THEN
         CALL AUFNUL
         CALL KOEFFH
         CALL QKOEFH
         IF (OMGH.GT.0.) CALL ITERAH
         IF (OMGH.LT.0.) CALL IADIST
         CALL FLIESS
         CALL KOPIER (2)
         CALL AUFNUL
         CALL KOEFFT (1,1,1,NX,NY,NZ)
         CALL QKOEFT
      END IF
C
C *** Subroutine ITERAT iterative Loesung des Temperaturfeldes *********
C
      IF (IGWF.EQ.2) THEN
         IF (OMGH.GT.0.) CALL ITERAH
         IF (OMGH.LT.0.) CALL IADIST
         CALL KOPIER (2)
      END IF
C
      IF (IGWF.LE.1) THEN
         IF (OMGT.GT.0.) CALL ITERAT
         IF (OMGT.LT.0.) CALL IADITP
         CALL KOPIER (1)
      END IF
C
      SUMSEK = SUMSEK + DZEIT
      DZEIT = DZEIT * DZF
C
      IF (IGWF.EQ.0) THEN 
         IF (IFROST.GT.0) CALL KOEFFT (1,1,1,NX,NY,NZ)
         CALL QKOEFT
      END IF   
      IF (IGWF.EQ.2) CALL QKOEFH
C
C *** Subroutine ZEITBE Ausgabe der abgelaufenen Zeit auf IUNIT ********
C
      CALL ZEITBE (IUNIT)
C
C *** Ueberpruefung des Abbruchkriteriums wenn ISTOP = 1 ***************
C
      IF (ISTOP.EQ.1.AND.NIT.EQ.1.AND.FEHLER.LT.FEHLT) THEN
         IF (IGWF.LE.1)   CALL TMPDRU
         IF (IGWF.GE.1)   CALL PIEDRU
         IF (IWSDAT.EQ.1) CALL WARMOU
         CALL ISODRV
         IF (IENER.EQ.1) THEN
            CALL ENERGI
            CALL WFLUSS (IZAEHL)
         END IF
         IF (IOBS.GT.0) CALL OBSDAT
         WRITE (1,120) FEHLT
         WRITE (IAUS,120) FEHLT
         WRITE (1,130)
         WRITE (IAUS,130)
         CALL ZEITCL
         STOP
      END IF
C
      IF (IZAEHL.EQ.IDRU) THEN
         IF (IGWF.LE.1)   CALL TMPDRU
         IF (IGWF.GE.1)   CALL PIEDRU
         IF (IWSDAT.EQ.1) CALL WARMOU
         CALL ISODRV
         IF (IENER.EQ.1) THEN
            CALL ENERGI
            CALL WFLUSS (IMAL)
         END IF
         IZAEHL = 0
      END IF
   20 CONTINUE
C
      IF (IEIN.EQ.IZEIT) THEN
         IF (IOBS.GT.0) CALL OBSDAT
         WRITE (IAUS,140)
         WRITE (1,140)
         CALL ZEITCL
         STOP
      END IF
      IAN = IABS(IAN - 1)
C
      DO 30 L = 1, LUMW
         CALL UMWAND (L,IAN)
   30 CONTINUE
C
      IF (IZAEHL.NE.0) THEN
         IF (IGWF.LE.1)   CALL TMPDRU
         IF (IGWF.GE.1)   CALL PIEDRU
         IF (IWSDAT.EQ.1) CALL WARMOU
         CALL ISODRV
         IF (IENER.EQ.1) THEN
            CALL ENERGI
            CALL WFLUSS (IZAEHL)
         END IF
      END IF
C
      IF (IGWF.LE.1) CALL KOPIER (1)
      IF (IAN.EQ.0) WRITE (IAUS,100)
      IF (IAN.EQ.1) WRITE (IAUS,110)
      IF (IOBS.GT.0) CALL OBSDAT
   10 CONTINUE
      WRITE (IAUS,140)
      WRITE (1,140)
      CALL ZEITCL
      STOP
  100 FORMAT(/,T16,' Energieentzug bzw. Energieeingabe gestoppt')
  110 FORMAT(/,T16,' Energieentzug bzw. Energieeingabe gestartet')
  120 FORMAT(/,T16,' Abbruchkriterium NIT = 1 und FEHLER < ',F8.6,
     &         ' erfuellt')
  130 FORMAT(T16,' Berechnung vorzeitig abgebrochen')
  140 FORMAT(T16,' TRADIKON-3D Simulation normal beendet')
      END
      BLOCK DATA FELDER
      PARAMETER (IWERT=5000,IKEYS=31)
      CHARACTER FORMOU*30,FORTXT*48
      CHARACTER FLAG*4,UFLS*4
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      DIMENSION FORMOU(8),FORTXT(8)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      COMMON /FORM/FORMOU,FORTXT
      COMMON /INCB/INDX,INDY,INDZ,IADD,JADD,KADD
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
      DATA INDX /-1,1,0,0,0,0/, INDY /0,0,-1,1,0,0/, INDZ /0,0,0,0,-1,1/
      DATA IADD /0,1,0,0/, JADD /0,0,1,0/, KADD /0,0,0,1/
      DATA FORMOU/
     &'(F6.2,10F6.0,/,9(6X,10F6.0,/))','(F6.2,10F6.2,/,9(6X,10F6.2,/))',
     &'(F6.2,10F6.2,/,9(6X,10F6.2,/))','(F6.2,10F6.2,/,9(6X,10F6.2,/))',
     &'(F6.2,10F6.2,/,9(6X,10F6.2,/))','(F6.2,10F6.2,/,9(6X,10F6.2,/))',
     &'(F6.2,10I6  ,/,9(6X,10I6  ,/))','(F6.2,10I6  ,/,9(6X,10I6  ,/))'/
      DATA FORTXT/'(/,'' Waermekapazitaet des Gesteins:''         )',
     &            '(/,'' Waermeleitfaehigkeit des Gesteins:''     )',
     &            '(/,'' Dichte des Gesteins:''                   )',
     &            '(/,'' Gesamtporositaet des Gesteins: (0 - 1)'' )',
     &            '(/,'' Nutzporositaet des Gesteins: (0 - 1)''   )',
     &            '(/,'' Waermeproduktion in Watt/cbm:''          )',
     &            '(/,'' Waermefluss - Flags:''                   )',
     &            '(/,'' Grundwasserfluss - Flags:''              )'/
      DATA UFLS/'CPGE','GWNB','GWVX','GWVY','GWVZ','HTOT','IFLG',
     &          'JFLG','LEAK','PHIG','PHIN','QUEL','RHOG','RNZF',
     &          'SPEI','SOUC','TRSX','TRSY','TRSZ','TTOT','TXYZ',
     &          'TEMP','WATT','WPXM','WPYM','WPZM','WPXY','WPXZ',
     &          'WPYZ','WLKG','WPOT'/
      END
C&AUFNUL
C **********************************************************************
C     Version 12071987  Subroutine AUFNUL
C **********************************************************************
C
C *** Subroutine AUFNUL Initialisieren der Koeffizienten - Felder ******
C
      SUBROUTINE AUFNUL
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
C
      IF (IECHO.GE.1) CALL ROUTIN ('AUFNUL')
C
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      DO 10 I = 1, NX
         AP0(I,J,K) = 0.
         AP1(I,J,K) = 0.
         B(I,J,K)   = 0.
         DO 20 L = 1, KD2
            WTI(I,J,K,L) = 0.
   20    CONTINUE
         DO 10 L = 1, KD
            ANB(I,J,K,L) = 0.
   10 CONTINUE
      DO 30 L = 1, KD
         FNB(L)  = 0.
         DNB(L)  = 0.
         PECL(L) = 1.
   30 CONTINUE
      RETURN
      END
C&DATAUS
C **********************************************************************
C     Version 11061987  Subroutine DATAUS
C **********************************************************************
C
C *** Subroutine DATAUS Ausdrucken der Eingangsdaten *******************
C
      SUBROUTINE DATAUS
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      COMMON /ENER/SC,SP,FRO
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /WPOT/H,H0

C
      IF (IECHO.GE.1) CALL ROUTIN ('DATAUS')
C
      DO 10 K = 1, NZ
      IF (IGWF.EQ.2) GO TO 500
      WRITE (6,100) K,ZKOR(K)
C *** Ausgangstemperatur in Grad Celsius *******************************
      WRITE (6,120) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 20 J = 1, NY
      WRITE (6,320) YKOR(J),(CELS(T(I,J,K)),I = 1, NX)
   20 CONTINUE
C *** Waermekapazitaet des Gesteins in J/kg*K **************************
      WRITE (6,130) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 30 J = 1, NY
   30 WRITE (6,330) YKOR(J),(CPG(I,J,K),I = 1, NX)
C *** Dichte des Gesteins in g/cbcm ************************************
      WRITE (6,140) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 40 J = 1, NY
   40 WRITE (6,320) YKOR(J),(GRCBCM(RHOG(I,J,K)),I = 1, NX)
C *** Waermeleitfaehigkeit des Gesteins in W/m*K ***********************
      WRITE (6,150) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 50 J = 1, NY
   50 WRITE (6,320) YKOR(J),(WLKG(I,J,K),I = 1, NX)
C *** Definition der Zellen ********************************************
      WRITE (6,160) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 60 J = 1, NY
   60 WRITE (6,360) YKOR(J),(IFLAG(I,J,K),I = 1, NX)
C *** Gesamtporositaet in den Zellen ***********************************
      WRITE (6,170) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 70 J = 1, NY
   70 WRITE (6,320) YKOR(J),(PHIG(I,J,K),I = 1, NX)
C *** Nutzporositaet in den Zellen *************************************
      WRITE (6,180) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 80 J = 1, NY
   80 WRITE (6,320) YKOR(J),(PHIN(I,J,K),I = 1, NX)
C *** interne Waermeproduktion in Watt/cbm *****************************
      WRITE (6,190) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 90 J = 1, NY
   90 WRITE (6,320) YKOR(J),(SC(I,J,K),I = 1, NX)
  500 IF (IGWF.GT.0) THEN
C *** Ausgangspiezometerhoehe in Meter *********************************
      WRITE (6,191) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 600 J = 1, NY
  600 WRITE (6,320) YKOR(J),(H(I,J,K),I = 1, NX)
C *** Speicherkoeffizient (-) ******************************************
      WRITE (6,192) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 610 J = 1, NY
  610 WRITE (6,370) YKOR(J),(SK(I,J,K),I = 1, NX)
C *** Quellen und Senken in cbm/s **************************************
      WRITE (6,193) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 620 J = 1, NY
  620 WRITE (6,370) YKOR(J),(Q(I,J,K),I = 1, NX)
C *** Definition der Zellen ********************************************
      WRITE (6,194) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 630 J = 1, NY
  630 WRITE (6,360) YKOR(J),(JFLAG(I,J,K),I = 1, NX)
C *** hydraulische Leitfaehigkeit in X-Richtung in m/s *****************
      WRITE (6,195) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 640 J = 1, NY
  640 WRITE (6,370) YKOR(J),(TTX(I,J,K),I = 1, NX)
C *** hydraulische Leitfaehigkeit in Y-Richtung in m/s *****************
      WRITE (6,196) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 650 J = 1, NY
  650 WRITE (6,370) YKOR(J),(TTY(I,J,K),I = 1, NX)
C *** hydraulische Leitfaehigkeit in Z-Richtung in m/s *****************
      WRITE (6,197) K,ZKOR(K)
      WRITE (6,310) (XKOR(I),I = 1, NX)
      DO 660 J = 1, NY
  660 WRITE (6,370) YKOR(J),(TTZ(I,J,K),I = 1, NX)
      END IF
   10 CONTINUE
C
      WRITE (6,210)
      WRITE (6,*) ' Knotenabstaende in X-Richtung  (Meter):'
      WRITE (6,340) (DIFX(I),I = 1, NX1)
      WRITE (6,210)
      WRITE (6,*) ' Knotenabstaende in Y-Richtung  (Meter):'
      WRITE (6,340) (DIFY(J),J = 1, NY1)
      WRITE (6,210)
      WRITE (6,*) ' Knotenabstaende in Z-Richtung  (Meter):'
      WRITE (6,340) (DIFZ(K),K = 1, NZ1)
  100 FORMAT(/,' Eingangsparameter von Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  120 FORMAT(/,' Ausgangstemperatur in Grad Celsius - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  130 FORMAT(/,' Waermekapazitaet in J/kg*K - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  150 FORMAT(/,' thermische Leitfaehigkeit in W/m*K - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  140 FORMAT(/,' Dichte des Gesteins in g/cbcm - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  160 FORMAT(/,' T-Flags: 1=var.Tmp. 2=konst.Tmp. 3=Wrmf. 4=Wkof. 5=Wtau
     &sch. - Schicht ',I2,' - ',F6.2,' m u. GOK')
  170 FORMAT(/,' Ges.Porositaet in den Zellen (0 - 1)    - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  180 FORMAT(/,' Nutzporositaet in den Zellen (0 - 1)    - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  190 FORMAT(/,' interne Waermeproduktion in Watt/cbm - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  191 FORMAT(/,' Ausgangspiezometerhoehe in Meter     - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  192 FORMAT(/,' Speicherkoeffizient (-)              - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  193 FORMAT(/,' Quellen und Senken in cbm/s          - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  194 FORMAT(/,' H-Flags: 1=var.Wsp. 2=konst.Wsp.               - Schich
     &t           ',I2,' - ',F6.2,' m u. GOK')
  195 FORMAT(/,' hydraulische Leitfaehigkeit in X-Ri. - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  196 FORMAT(/,' hydraulische Leitfaehigkeit in Y-Ri. - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  197 FORMAT(/,' hydraulische Leitfaehigkeit in Z-Ri. - Schicht ',I2,
     &       ' - ',F6.2,' m u. GOK')
  210 FORMAT(/)
  310 FORMAT('    Y\X ',10F8.2,/,50(8X,10F8.2,/))
  320 FORMAT(F8.2,10F8.2,/,50(8X,10F8.2,/))
  330 FORMAT(F8.2,10F8.0,/,50(8X,10F8.0,/))
  340 FORMAT(50(10F8.2,/))
  360 FORMAT(F8.2,10I8,/,50(8X,10I8,/))
  370 FORMAT(F8.2,10F8.5,/,50(8X,10F8.5,/))
      RETURN
      END
C&DATEIN
C **********************************************************************
C     Version 11061987  Subroutine DATEIN
C **********************************************************************
C
C *** Subroutine DATEIN Einlesen der Daten - langer Input **************
C
      SUBROUTINE DATEIN
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELV
      CHARACTER FORMIN*20
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /ENER/SC,SP,FRO
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /WPOT/H,H0
      PI = ATAN(1.) * 4.
C
      IF (IECHO.GE.1) CALL ROUTIN ('DATEIN')
C
C *** optionale Eingabe der Anisotropiefaktoren fuer WLKG **************
C
      READ (5,100) FORMIN
      READ (5,FORMIN) IBX,IBY,IBZ,ANISO(1),ANISO(2),ANISO(3)
C
C *** Subroutine GITTER Berechnung der Gitterparameter *****************
C
      CALL GITTER
      IF (IGWF.EQ.2) GO TO 1000
C *** Ausgangstemperatur in Grad Celsius *******************************
      CALL READMD (T,IX,IY,IZ)
C *** Waermekapazitaet des Gesteins in J/kg*K **************************
      CALL READMR (CPG,IX,IY,IZ)
C *** Dichte des Gesteins **********************************************
      CALL READMR (RHOG,IX,IY,IZ)
C *** Waermeleitfaehigkeit des Gesteins in W/m*K ***********************
      CALL READMR (WLKG,IX,IY,IZ)
C *** Definition der Zellen ********************************************
      CALL READMI (IFLAG,IX,IY,IZ)
C *** Gesamtporositaet in den Zellen ***********************************
      CALL READMR (PHIG,IX,IY,IZ)
C *** Nutzporositaet in den Zellen *************************************
      CALL READMR (PHIN,IX,IY,IZ)
C *** Wassersaettigung in den Zellen in Prozent ************************
      READ (5,100) FORMIN
      READ (5,FORMIN) (SATU(K), K = 1, NZ)
      DO 10 K = 1, NZ
   10 SATU(K) = SATU(K) / 100.
C *** interne Waermeproduktion in Watt/cbm *****************************
      CALL READMR (SC,IX,IY,IZ)
      IF (IGWF.EQ.0.AND.IDIF.EQ.1) THEN
C *** Fliessgeschwindigkeit in m/sec in X - Richtung *******************
          CALL READMR (VX,IX,IY,IZ)
C *** Fliessgeschwindigkeit in m/sec in Y - Richtung *******************
          CALL READMR (VY,IX,IY,IZ)
C *** Fliessgeschwindigkeit in m/sec in Z - Richtung *******************
          CALL READMR (VZ,IX,IY,IZ)
      END IF
      DO 20 K = 1, NZ
      DO 20 J = 1, NY
      DO 20 I = 1, NX
      T(I,J,K)    =  CELV (T(I,J,K))
      RHOG(I,J,K) =  RHOG(I,J,K) * 1000.
      PHIN(I,J,K) =  PHIN(I,J,K) / 100.
      PHIG(I,J,K) =  PHIG(I,J,K) / 100.
   20 CONTINUE
 1000 IF (IGWF.GE.1) THEN
C *** Piezometerhoehen in Meter ****************************************
         CALL READMR (H,IX,IY,IZ)
C *** hydraulische Leitfaehigkeit in X - Richtung **********************
         CALL READMR (TTX,IX,IY,IZ)
C *** hydraulische Leitfaehigkeit in Y - Richtung **********************
         CALL READMR (TTY,IX,IY,IZ)
C *** hydraulische Leitfaehigkeit in Z - Richtung **********************
         CALL READMR (TTZ,IX,IY,IZ)
C *** Entnahmen und Zugaben in cbm/s ***********************************
         CALL READMR (Q,IX,IY,IZ)
C *** spezifischer Speicherkoeffizient *********************************
         CALL READMR (SK,IX,IY,IZ)
         IF (IGWF.GT.1) THEN
C *** Nutzporositaet in den Zellen *************************************
            CALL READMR (PHIN,IX,IY,IZ)
            DO 30 K = 1, NZ
            DO 30 J = 1, NY
            DO 30 I = 1, NX
            PHIN(I,J,K) = PHIN(I,J,K) / 100.
   30       CONTINUE
         END IF
C *** Definition der Zellen ********************************************
         CALL READMI (JFLAG,IX,IY,IZ)
      END IF
  100 FORMAT(A20)
      RETURN
      END
C&DELTAH
C **********************************************************************
C     Version 23031988  Subroutine DELTAH
C **********************************************************************
C
C *** Subroutine DELTAH Berechnung der benetzten Interfacehoehe ********
C
      SUBROUTINE DELTAH (I,J,K)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      COMMON /INCB/INDX,INDY,INDZ,IADD,JADD,KADD
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      DO 10 L = 1, 3
         II = I - IADD(L)
         JJ = J - JADD(L)
         IF (II.LE.0.OR.II.GE.NX) GO TO 10
         IF (JJ.LE.0.OR.JJ.GE.NY) GO TO 10
         CALL KONDUK (II,JJ,K)
   10 CONTINUE
      CALL KONKOF (I,J,K)
      AP = 0.
      DO 20 L = 1, KD
         ANB(I,J,K,L) = DNB(L)
         AP = AP + ANB(I,J,K,L)
   20 CONTINUE
      AP1(I,J,K) = AP + AP0(I,J,K)
      RETURN
      END
C&DKTEST
C **********************************************************************
C     Version 19021988  Subroutine DKTEST
C **********************************************************************
C
C *** Subroutine DKTEST Ueberpruefung der Diskretisierungsvorschriften *
C
      SUBROUTINE DKTEST
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
C
      IF (IECHO.GE.1) CALL ROUTIN ('DKTEST')
C
C **********************************************************************
C
C                    ABS(VX) * DX                         K
C            2  =>   ------------    wobei:   ALFA  =  -------
C                       ALFA                           RHO * Cp
C
C **********************************************************************
C
      PKRIT = 0.
      ALFA = WLW / RHOW / CPW
      DO 10 K = 1, NZ1
      DO 10 J = 1, NY1
      DO 10 I = 1, NX1
C
C *** in X - Richtung ... **********************************************
C
      GIPEZ = ABS(VX(I,J,K)) * DIFX(I) / ALFA
      IF (GIPEZ.GT.PKRIT) THEN
         PKRIT = GIPEZ
         II = I
         JJ = J
         KK = K
      END IF
C
C *** in Y - Richtung ... **********************************************
C
      GIPEZ = ABS(VY(I,J,K)) * DIFY(J) / ALFA
      IF (GIPEZ.GT.PKRIT) THEN
         PKRIT = GIPEZ
         II = I
         JJ = J
         KK = K
      END IF
C
C *** in Z - Richtung ... **********************************************
C
      GIPEZ = ABS(VZ(I,J,K)) * DIFZ(K) / ALFA
      IF (GIPEZ.GT.PKRIT) THEN
         PKRIT = GIPEZ
         II = I
         JJ = J
         KK = K
      END IF
   10 CONTINUE
C
      IF (PKRIT.GT.2.) THEN
         IF (IECHO.GE.1) WRITE (1,100) II,JJ,KK,PKRIT
         WRITE (6,120)
         WRITE (6,100) II,JJ,KK,PKRIT
         IF (IDSTOP.EQ.2) THEN
           WRITE (1,130)
           WRITE (6,130)
           CALL ZEITCL
           STOP
         END IF
         RETURN
      END IF
      IF (IECHO.GE.1) WRITE (1,110)
      RETURN
  100 FORMAT(' Achtung!!!     Gitter-Peclet-Zahl an Knoten (',3I3,
     &       ') mit ',F10.3,' zu gross',/,
     &       ' Abhilfe:  -->  Knotenabstaende verkleinern')
  110 FORMAT(T17,'Diskretisierungsvorschriften wurden eingehalten')
  120 FORMAT(/)
  130 FORMAT(T17,'IDSTOP aktiv  -  Simulation vorzeitig abgebrochen')
      END
C&DZTEST
C **********************************************************************
C     Version 27101987  Subroutine DZTEST
C **********************************************************************
C
C *** Subroutine DZTEST Ueberpruefung der Zeitschrittlaenge ************
C
      SUBROUTINE DZTEST (ITEST)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
C
      IF (IECHO.GE.1) CALL ROUTIN ('DZTEST')
C
C **********************************************************************
C
C                          RHO * Cp * DX * DX
C                  DT  <   ------------------
C                                 2 * K
C
C **********************************************************************
C
      DTMAX = 1.E10
      DZT   = DZEIT
      WLKW  = WLW
      CPF   = CPW
      ROW   = RHOW
C
C *** fuer den unguenstigsten Fall beim Gefrieren von Wasser gilt ... **
C
      IF (IFROST.GE.1) THEN
         WLKW = WLE
         CPF  = CPE
         ROW  = RHOE
      END IF
C
      DO 10 K = 1, NZ
      CPP  =  CPF * SATU(K) + CPL * (1. - SATU(K))
      RHOP =  ROW * SATU(K) + RHOL * (1. - SATU(K))
      WLP  =  WLKW * SATU(K) + WLL * (1. - SATU(K))
      DO 10 J = 1, NY
      DO 10 I = 1, NX
      IF (WLKG(I,J,K).EQ.0..AND.(PHIG(I,J,K).EQ.0..OR.SATU(K).EQ.0.))
     &   GO TO 10
      POR  =  PHIG(I,J,K)
      SOL  =  1. - POR
      RHOC2K = ((SOL * RHOG(I,J,K) + POR * RHOP) *
     &         (SOL * CPG(I,J,K) + POR * CPP)) /
     &         (2. * (SOL * WLKG(I,J,K) + POR * WLP))
      ZEIT = RHOC2K * DELTAX(I) * DELTAX(I)
      IF (ZEIT.NE.0..AND.ZEIT.LT.DTMAX) DTMAX = ZEIT
      ZEIT = RHOC2K * DELTAY(J) * DELTAY(J)
      IF (ZEIT.LT.DTMAX) DTMAX = ZEIT
      IF (ZEIT.NE.0..AND.ZEIT.LT.DTMAX) DTMAX = ZEIT
      ZEIT = RHOC2K * DELTAZ(K) * DELTAZ(K)
      IF (ZEIT.LT.DTMAX) DTMAX = ZEIT
      IF (ZEIT.NE.0..AND.ZEIT.LT.DTMAX) DTMAX = ZEIT
   10 CONTINUE
      IF (DZT.LT.DZEIT) THEN
         WRITE (1,100) DZEIT/60.,DZT/60.
         WRITE (IAUS,100) DZEIT/60.,DZT/60.
         IF (IDZTST.NE.2) RETURN
         STPALT = ITEST
         ITEST = NINT(ITEST * DZEIT / DZT) + 1
         IZEIT = NINT(ITEST / STPALT * IZEIT)
         DZEIT = DZEIT / ITEST * STPALT
         WRITE (1,110) DZEIT / 60.
         WRITE (IAUS,110) DZEIT / 60.
         RETURN
      END IF
      WRITE (1,120) DTMAX / 60.
  100 FORMAT(/,' Zeitschrittlaenge mit ',F8.0,' Min. zu gross - maximal
     &',F5.0,' Min. erlaubt')
  110 FORMAT(' Zeitschrittlaenge wurde auf ',F8.1,' Minuten verkuerzt!
     &')
  120 FORMAT(' Zeitschrittlaenge darf max. ',F8.1,' Minuten betragen')
      RETURN
      END
C&ENERGI
C **********************************************************************
C     Version 13071987  Subroutine ENERGI
C **********************************************************************
C
C *** Subroutine ENERGI Berechnung der Waermeenergie in den Zellen *****
C
      SUBROUTINE ENERGI
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      IMPLICIT DOUBLE PRECISION (E)
      DOUBLE PRECISION T,T0,STMP,TEMP,STEMP
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      COMMON /EKAL/EALT,EANF,ESUM
      COMMON /ENER/SC,SP,FRO
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /TEMP/T,T0,STMP
C
      IF (IECHO.GE.1) CALL ROUTIN ('ENERGI')
C
      EGES = 0.
      DO 10 K = 1, NZ
      STEMP = STMP(K)
      DO 10 J = 1, NY
      DO 10 I = 1, NX
      TEMP = T(I,J,K)
      CALL ZELLEN (I,J,K,TEMP,STEMP)
      EGES = EGES + ESUM
   10 CONTINUE
      IF (IEN1.EQ.1) THEN
         EANF = EGES
         ENEU = EGES
         EBIL = 0.
      ELSE
         ENEU = EGES
         EBIL = ENEU - EALT
         ETOT = EGES - EANF
      END IF
      EALT = ENEU
      WRITE (IAUS,30) EGES
      WRITE (IAUS,40) EBIL
      WRITE (IAUS,50) ETOT
      IEN1 = 0
   30 FORMAT(/,' Energieinhalt gesamt:                       ',1PE15.6,
     &         ' Joule')
   40 FORMAT(' Energiebilanz seit dem letzten Ausdruck:    ',1PE15.6,
     &       ' Joule')
   50 FORMAT(' Energiebilanz seit Beginn der Simulation:   ',1PE15.6,
     &       ' Joule')
      RETURN
      END
C&FLIESS
C **********************************************************************
C     Version 12041988  Subroutine FLIESS
C **********************************************************************
C
C *** Subroutine FLIESS Berechnung der Fliessgeschwindigkeiten *********
C
      SUBROUTINE FLIESS
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /WPOT/H,H0
C
      IF (IECHO.GE.1) CALL ROUTIN ('FLIESS')
C
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      DO 10 I = 1, NX
         VX(I,J,K) = 0.
         VY(I,J,K) = 0.
         VZ(I,J,K) = 0.
C
C *** Fliessgeschwindigkeit in X - Richtung ****************************
C
         IF (I.EQ.NX) GO TO 20
         CALL HARMON (PHIN(I,J,K),PHIN(I+1,J,K),POR,FX(I))
         VX(I,J,K) = WTI(I,J,K,1) * (H(I,J,K) - H(I+1,J,K)) / DIFX(I)
         VX(I,J,K) = VX(I,J,K) / POR
C
C *** Fliessgeschwindigkeit in Y - Richtung ****************************
C
   20    IF (J.EQ.NY) GO TO 30
         CALL HARMON (PHIN(I,J,K),PHIN(I,J+1,K),POR,FY(J))
         VY(I,J,K) = WTI(I,J,K,2) * (H(I,J,K) - H(I,J+1,K)) / DIFY(J)
         VY(I,J,K) = VY(I,J,K) / POR
C
C *** Fliessgeschwindigkeit in Z - Richtung ****************************
C
   30    IF (K.EQ.NZ) GO TO 10
         CALL HARMON (PHIN(I,J,K),PHIN(I,J,K+1),POR,FZ(K))
         VZ(I,J,K) = WTI(I,J,K,3) * (H(I,J,K) - H(I,J,K+1)) / DIFZ(K)
         VZ(I,J,K) = VZ(I,J,K) / POR
   10 CONTINUE
      RETURN
      END
C&FLUKOF
C **********************************************************************
C     Version 29061987  Subroutine FLUKOF
C **********************************************************************
C
C *** Subroutine FLUKOF Berechnung der Konvektionskoeffizienten ********
C
      SUBROUTINE FLUKOF (I,J,K)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
C
      DO 50 L = 1, KD
         FNB(L) = 0.
   50 CONTINUE
      TMP = CELS(T(I,J,K))
      STP = CELS(STMP(K))
      ROW = RHOH2O(TMP,STP,K)
      IF (IGWF.EQ.0) IF (IFLUS(I,J,K)) 20,30,10
C
C *** nur horizontaler Fluss *******************************************
C
   10 IF (I.GT.1)  FNB(1) = ROW * VX(I-1,J,K) * DELTAY(J) * DELTAZ(K)
      IF (I.LE.NX) FNB(2) = ROW * VX(I,J,K)   * DELTAY(J) * DELTAZ(K)
      IF (J.GT.1)  FNB(3) = ROW * VY(I,J-1,K) * DELTAZ(K) * DELTAX(I)
      IF (J.LE.NY) FNB(4) = ROW * VY(I,J,K)   * DELTAZ(K) * DELTAX(I)
      IF (IGWF.EQ.0) RETURN
C
C *** nur vertikaler Fluss *********************************************
C
   20 CONTINUE
      IF (K.GT.1)  FNB(5) = ROW * VZ(I,J,K-1) * DELTAX(I) * DELTAY(J)
      IF (K.LE.NZ) FNB(6) = ROW * VZ(I,J,K)   * DELTAX(I) * DELTAY(J)
   30 RETURN
      END
C&FLUSFL
C **********************************************************************
C     Version 10061987  Subroutine FLUSFL
C **********************************************************************
C
C *** Subroutine FLUSFL Festlegung der Flowflags ***********************
C
      SUBROUTINE FLUSFL (I1,J1,K1,I2,J2,K2)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
C
      IF (IECHO.GE.1) CALL ROUTIN ('FLUSFL')
C
C      IFLUS =  -1  ==>  nur vertikaler Fluss
C      IFLUS =   0  ==>  kein Fluss
C      IFLUS =   1  ==>  nur horizontaler Fluss
C
      DO 10 K = K1, K2
      DO 10 J = J1, J2
      DO 10 I = I1, I2
         IFLUS(I,J,K) = 0
         IF (T(I,J,K).GE.STMP(K) .AND. PHIN(I,J,K).GT.0. .AND.
     &      SATU(K).LT.1.) IFLUS(I,J,K) = -1
         IF (T(I,J,K).GE.STMP(K) .AND. PHIN(I,J,K).GT.0.)
     &      IFLUS(I,J,K) =  1
         IF (IFLAG(I,J,K).EQ.5) IFLUS(I,J,K) = 0
   10 CONTINUE
C
C *** optionale Ausgabe der Flowflags **********************************
C
      IF (IAUSOP.EQ.3) THEN
      DO 20 K = 1, NZ
         WRITE (IAUS,30) K,ZKOR(K)
         WRITE (IAUS,50) (XKOR(I),I = 1, NX)
         DO 20 J = 1, NY
            WRITE (IAUS,40) YKOR(J),(IFLUS(I,J,K),I = 1, NX)
   20    CONTINUE
      END IF
   30 FORMAT(/,' Fluss: -1 => nur VZ 0 => kein 1 => nur VX + VY',
     &       ' - Schicht ',I2,' - ',F6.2,' m u. GOK')
   40 FORMAT(F7.2,10I6,/,9(7X,10I6,/))
   50 FORMAT('   Y\X ',10F6.2,/,9(7X,10F6.2,/))
      RETURN
      END
C&FUNKTI
C **********************************************************************
C     Version 22061987  Double Precision Function CELS
C **********************************************************************
C
C *** Double Precision Function CELS Umrechnung Kelvin/Celsius *********
C
      DOUBLE PRECISION FUNCTION CELS(CELVIN)
      DOUBLE PRECISION CELVIN
      CELS = CELVIN - 273.15D00
      RETURN
      END
C **********************************************************************
C     Version 18021988  Double Precision Function CELV
C **********************************************************************
C
C *** Double Precision Function CELV Umrechnung Celsius/Kelvin *********
C
      DOUBLE PRECISION FUNCTION CELV(CELSIU)
      DOUBLE PRECISION CELSIU
      CELV = CELSIU + 273.15D00
      RETURN
      END
C **********************************************************************
C     Version 22061987  Function GRCBCM
C **********************************************************************
C
C *** Function GRCBCM Umrechnung kg/cbm in g/cbcm **********************
C
      FUNCTION GRCBCM(KGCBM)
      REAL KGCBM
      GRCBCM = KGCBM / 1000.
      RETURN
      END
C **********************************************************************
C     Version 14071987  Function RHOH2O
C **********************************************************************
C
C *** Function RHOH2O Berechnung der Dichte von Wasser *****************
C
      FUNCTION RHOH2O(TMP,STP,K)
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      IF (TMP.GE.STP) THEN
        RHOH2O = RHOW
        RETURN
      END IF
      CALL WASEIS (WE,TMP - STP,K)
      RHOH2O = WE * RHOW + (1. - WE) * RHOE
      RETURN
      END
C **********************************************************************
C     Version 07051988  Function VISKIN
C **********************************************************************
C
C *** Function VISKIN Berechnung der kinem. Viskositaet von Wasser *****
C
      FUNCTION VISKIN(TT)
      TT = TT - 273.15
      VISKIN = 0.88977 * (1. + 1.70623 * EXP(-0.03406 * TT)) - 0.635
      RETURN
      END
C&GITTER
C **********************************************************************
C     Version 10061987  Subroutine GITTER
C **********************************************************************
C
C *** Subroutine GITTER Berechnung der Gitterparameter *****************
C
      SUBROUTINE GITTER
      PARAMETER (IW=1,IE=2,IN=1,IS=2,IT=1,IB=2)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      CHARACTER FORMIN*20,CARD*3
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
C
      IF (IECHO.GE.1) CALL ROUTIN ('GITTER')
C
C     IVOLDF  =  0    =>  Knotenpunkt liegt im geometrischen Zentrum
C     IVOLDF  =  1    =>  Interfaceflaechen liegen auf halber Strecke
C                         zwischen den Knotenpunkten
C
      IF (IVOLDF.EQ.0) THEN
         CARD = '21'
         READ (5,500,END=600) FORMIN
         READ (5,FORMIN,ERR=700,END=600) (DELTAX(I),I = 1, NX)
         CARD = '23'
         READ (5,500,END=600) FORMIN
         READ (5,FORMIN,ERR=700,END=600) (DELTAY(J),J = 1, NY)
         CARD = '25'
         READ (5,500,END=600) FORMIN
         READ (5,FORMIN,ERR=700,END=600) (DELTAZ(K),K = 1, NZ)
         GO TO 50
      END IF
      IF (IVOLDF.EQ.1) THEN
         NXX = NX1
         NYY = NY1
         NZZ = NZ1
         IF (NX1.EQ.0) NXX = 1
         IF (NY1.EQ.0) NYY = 1
         IF (NZ1.EQ.0) NZZ = 1
         CARD = '21'
         READ (5,500,END=600) FORMIN
         READ (5,FORMIN,ERR=700,END=600) (DIFX(I),I = 1, NXX)
         CARD = '23'
         READ (5,500,END=600) FORMIN
         READ (5,FORMIN,ERR=700,END=600) (DIFY(J),J = 1, NYY)
         CARD = '25'
         READ (5,500,END=600) FORMIN
         READ (5,FORMIN,ERR=700,END=600) (DIFZ(K),K = 1, NZZ)
      END IF
C
C *** Berechnung der Zellenbreite **************************************
C
      IF (NX.EQ.1) THEN
         DELTAX(1) = DIFX(1)
         GO TO 15
      END IF
      DELTAX(1) = DIFX(1)/2.
      DELTAX(NX) = DIFX(NX1)/2.
      DO 10 I = 2, NX1
         DELTAX(I) = DIFX(I-1) * 0.5 + DIFX(I) * 0.5
   10 CONTINUE
C
C *** Berechnung der Zellentiefe ***************************************
C
   15 IF (NY.EQ.1) THEN
         DELTAY(1) = DIFY(1)
         GO TO 25
      END IF
      DELTAY(1) = DIFY(1) / 2.
      DELTAY(NY) = DIFY(NY1) / 2.
      DO 20 J = 2,NY1
         DELTAY(J) = DIFY(J-1) * 0.5 + DIFY(J) * 0.5
   20 CONTINUE
C
C *** Berechnung der Zellenhoehe ***************************************
C
   25 IF (NZ.EQ.1) THEN
         DELTAZ(1) = DIFZ(1)
         GO TO 50
      END IF
      DELTAZ(1) = DIFZ(1) / 2.
      DELTAZ(NZ) = DIFZ(NZ1) / 2.
      DO 30 K = 2, NZ1
         DELTAZ(K) = DIFZ(K-1) * 0.5 + DIFZ(K) * 0.5
   30 CONTINUE
   50 CONTINUE
C
C *** Berechnung der Zellenvolumina ************************************
C
      DO 40 K = 1, NZ
      DO 40 J = 1, NY
      DO 40 I = 1, NX
         DXYZ(I,J,K) = DELTAX(I) * DELTAY(J) * DELTAZ(K)
   40 CONTINUE
      IF (IVOLDF.EQ.1) GO TO 1000
C
C *** falls Knoten im geometrischen Zentrum ****************************
C
      DO 80 I = 1, NX1
         DIFX(I) = DELTAX(I) * 0.5 + DELTAX(I+1) * 0.5
   80 CONTINUE
C
C *** Berechnung des Knotenabstaende in Y - Richtung *******************
C
      DO 90 J = 1, NY1
         DIFY(J) = DELTAY(J) * 0.5 + DELTAY(J+1) * 0.5
   90 CONTINUE
C
C *** Berechnung des Knotenabstaende in Z - Richtung *******************
C
      DO 100 K = 1, NZ1
         DIFZ(K) = DELTAZ(K) * 0.5 + DELTAZ(K+1) * 0.5
  100 CONTINUE
C
C *** Berechnung der Absolutkoordinaten der Knoten ********************
C
 1000 CONTINUE
      XKOR(1) = 0.
      YKOR(1) = 0.
      ZKOR(1) = 0.
C
C *** falls Knoten im geometrischen Zentrum ****************************
C
      IF (IVOLDF.EQ.0) THEN
         XKOR(1) = DELTAX(1) / 2.
         YKOR(1) = DELTAY(1) / 2.
         ZKOR(1) = DELTAZ(1) / 2.
      END IF
      DO 110 I = 2, NX
         XKOR(I) = XKOR(I-1) + DIFX(I-1)
  110 CONTINUE
      DO 120 J = 2, NY
         YKOR(J) = YKOR(J-1) + DIFY(J-1)
  120 CONTINUE
      DO 130 K = 2, NZ
         ZKOR(K) = ZKOR(K-1) + DIFZ(K-1)
  130 CONTINUE
C
C *** Berechnung der Knoten-Interface-Strecken *************************
C
      IF (IVOLDF.EQ.0) GO TO 240
C
      IF (NX.EQ.1) GO TO 215
      DIVX(1,IW)  = 0.
      DIVX(1,IE)  = DIFX(1) / 2.
      DIVX(NX,IW) = DIFX(NX1) / 2.
      DIVX(NX,IE) = 0.
C
      DO 210 I = 2, NX1
         DIVX(I,IW) = DIFX(I-1) / 2.
         DIVX(I,IE) = DIFX(I) / 2.
  210 CONTINUE
C
  215 IF (NY.EQ.1) GO TO 225
      DIVY(1,IN)  = 0.
      DIVY(1,IS)  = DIFY(1) / 2.
      DIVY(NY,IN) = DIFY(NY1) / 2.
      DIVY(NY,IS) = 0.
C
      DO 220 J = 2, NY1
         DIVY(J,IN) = DIFY(J-1) / 2.
         DIVY(J,IS) = DIFY(J) / 2.
  220 CONTINUE
C
  225 IF (NZ.EQ.1) GO TO 280
      DIVZ(1,IT)  = 0.
      DIVZ(1,IB)  = DIFZ(1) / 2.
      DIVZ(NZ,IT) = DIFZ(NZ1) / 2.
      DIVZ(NZ,IB) = 0.
C
      DO 230 K = 2, NZ1
         DIVZ(K,IT) = DIFZ(K-1) / 2.
         DIVZ(K,IB) = DIFZ(K) / 2.
  230 CONTINUE
      GO TO 280
  240 CONTINUE
C
C *** falls Knoten im geometrischen Zentrum ****************************
C
      DO 250 I = 1, NX
         DIVX(I,IW) = DELTAX(I) / 2.
         DIVX(I,IE) = DELTAX(I) / 2.
  250 CONTINUE
C
      DO 260 J = 1, NY
         DIVY(J,IN) = DELTAY(J) / 2.
         DIVY(J,IS) = DELTAY(J) / 2.
  260 CONTINUE
C
      DO 270 K = 1, NZ
         DIVZ(K,IT) = DELTAZ(K) / 2.
         DIVZ(K,IB) = DELTAZ(K) / 2.
  270 CONTINUE
  280 CONTINUE
      RETURN
  600 WRITE (1,610) CARD
      STOP
  700 WRITE (1,710) CARD
      STOP
  500 FORMAT(A20)
  610 FORMAT(' unerwartet Ende der Eingabedatei erreicht in Karte ',A3)
  710 FORMAT(' fehlerhafte Datenstruktur in Karte ',A3)
      END
C&HARMON
C **********************************************************************
C     Version 23011988  Subroutine HARMON
C **********************************************************************
C
C *** Subroutine HARMON Berechnung des gewichteten, harmonischen Mittels
C
      SUBROUTINE HARMON (A,B,C,F)
      IF (A.EQ.0..OR.B.EQ.0.) THEN
        C = 0.
        RETURN
      END IF
      C = A * B / ((1. - F) * A + F * B)
      RETURN
      END
C&HEADER
C **********************************************************************
C     Version 03081988  Subroutine HEADER
C **********************************************************************
C
C *** Subroutine HEADER Ausgabe des Headers ****************************
C
      SUBROUTINE HEADER (IR)
      CHARACTER HEAD1*39,HEAD2*36,HEAD3*28
      DIMENSION HEAD1(7),HEAD2(7),HEAD3(8)
      DATA HEAD1/'TTTTTTTT  RRRRRRR      AAA     DDDDDD  ',
     &           'TTTTTTTT  RR    RR    AA AA    DD   DD ',
     &           '   TT     RR    RR   AA   AA   DD    DD',
     &           '   TT     RRRRRR    AAAAAAAAA  DD    DD',
     &           '   TT     RR  RR    AAA   AAA  DD    DD',
     &           '   TT     RR   RR   AA     AA  DD   DD ',
     &           '   TT     RR    RR  AA     AA  DDDDDD  '/
      DATA HEAD2/'IIIIII  KK    KK   OOOO    NN     NN',
     &           'IIIIII  KK   KK   OO  OO   NNNN   NN',
     &           '  II    KK  KK   OO    OO  NN NN  NN',
     &           '  II    KKKKK    OO    OO  NN  NN NN',
     &           '  II    KK  KK   OO    OO  NN   NNNN',
     &           'IIIIII  KK   KK   OO  OO   NN    NNN',
     &           'IIIIII  KK    KK   OOOO    NN     NN'/
      DATA HEAD3/' 33333             DDDDDD  ',
     &           '33   33            DD   DD ',
     &           '     33            DD    DD',
     &           '   333    ======   DD    DD',
     &           '     33            DD    DD',
     &           '33   33            DD   DD ',
     &           ' 33333             DDDDDD  ',
     &           '  Version 1.31 22/02/2006  '/
C
      IF (IR.EQ.1) WRITE (IR,50)
      IF (IR.EQ.6) WRITE (IR,75)
      WRITE (IR,250)
      WRITE (IR,125)
      DO 10 I = 1, 7
         WRITE (IR,100) HEAD1(I),HEAD2(I)
   10 CONTINUE
      WRITE (IR,150)
      DO 20 I = 1, 7
         WRITE (IR,200) HEAD3(I)
   20 CONTINUE
      DO 30 I = 1, IR
         WRITE (IR,125)
   30 CONTINUE
      WRITE (IR,200) HEAD3(8)
      WRITE (IR,125)
      IF (IR.EQ.6) WRITE (IR,350)
      WRITE (IR,250)
      WRITE (IR,300)
      WRITE (IR,250)
      IF (IR.EQ.6) WRITE (IR,75)
   50 FORMAT(25(/))
   75 FORMAT(1H1)
  100 FORMAT(1H ,A39,2X,A36)
  125 FORMAT(1H )
  150 FORMAT(/)
  200 FORMAT(T27,A28)
  250 FORMAT(79(1H*))
  300 FORMAT('Dirk R. Brehm c/o BGU Dr.Brehm & Gruenz GbR - www.bgu-geos
     &ervice.de - Bielefeld')
  350 FORMAT(10(/))
      RETURN
      END
C&IADIST
C **********************************************************************
C     Version 21071988  Subroutine IADIST
C **********************************************************************
C
C *** Subroutine IADIST Stroemungsberechnung nach dem IADI-Verfahren ***
C
      SUBROUTINE IADIST
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION UU,AA,BB,CC,DD,ERR,FEHL
      DIMENSION UU(IMAX),AA(IMAX),BB(IMAX),CC(IMAX),DD(IMAX)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IADI/UU,AA,BB,CC,DD
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /WPOT/H,H0
   90 OMEGA = - OMGH
      IF (IECHO.GE.1) CALL ROUTIN ('IADIST')
      IAUSOP = 1
      NIT = 0
      M = 0
      IF (IECHO.GE.1) WRITE (1,*)
 1000 NIT = NIT + 1
      FEHL = 0.
      M = M + 1
C
C *** Zeilenberechnung *************************************************
C
      IF (NX.EQ.1) GO TO 170
      CALL RICHTG (M,KANF,KEND,KPLUS,NZ,1)
      DO 160 K = KANF, KEND, KPLUS
      N = K
      IF (NZ.EQ.1) N = M
      HO = HOENN - ZKOR(K) - DIVZ(K,2) + DELTAZ(K)
      CALL RICHTG (N,JANF,JEND,JPLUS,NY,1)
      DO 160 J = JANF, JEND, JPLUS
      DO 100 I = 1, NX
      AA(I) = - ANB(I,J,K,1)
      CC(I) = - ANB(I,J,K,2)
      BB(I) = AP1(I,J,K)
      DD(I) = 0.
      IF (J.EQ.1)  GO TO 120
      DD(I) =         H(I,J-1,K) * ANB(I,J,K,3)
  120 IF (J.EQ.NY) GO TO 130
      DD(I) = DD(I) + H(I,J+1,K) * ANB(I,J,K,4)
  130 IF (K.EQ.1)  GO TO 140
      DD(I) = DD(I) + H(I,J,K-1) * ANB(I,J,K,5)
  140 IF (K.EQ.NZ) GO TO 150
      DD(I) = DD(I) + H(I,J,K+1) * ANB(I,J,K,6)
  150 DD(I) = DD(I) + B(I,J,K)
      UU(I) = H(I,J,K)
  100 CONTINUE
      CALL THOMAS (NX)
      DO 160 I = 1, NX
      HALT = H(I,J,K)
      H(I,J,K) = H(I,J,K) + OMEGA * (UU(I) - H(I,J,K))
      HNEU = H(I,J,K)
      ERR = ABS(HNEU - HALT)
      IF (ERR.GT.FEHL) FEHL = ERR
      IF (HALT.LT.HO.AND.HNEU.GT.HO) CALL DELTAH (I,J,K)
      IF (HNEU.LT.HO) CALL DELTAH (I,J,K)
  160 CONTINUE
  170 CONTINUE
C
C *** Spaltenberechnung ************************************************
C
      IF (NY.EQ.1) GO TO 270
      CALL RICHTG (M,IANF,IEND,IPLUS,NX,1)
      DO 260 I = IANF, IEND, IPLUS
      CALL RICHTG (I,KANF,KEND,KPLUS,NZ,1)
      DO 260 K = KANF, KEND, KPLUS
      HO = HOENN - ZKOR(K) - DIVZ(K,2) + DELTAZ(K)
      DO 200 J = 1, NY
      AA(J) = - ANB(I,J,K,3)
      CC(J) = - ANB(I,J,K,4)
      BB(J) = AP1(I,J,K)
      DD(J) = 0.
      IF (I.EQ.1)  GO TO 220
      DD(J) =         H(I-1,J,K) * ANB(I,J,K,1)
  220 IF (I.EQ.NX) GO TO 230
      DD(J) = DD(J) + H(I+1,J,K) * ANB(I,J,K,2)
  230 IF (K.EQ.1)  GO TO 240
      DD(J) = DD(J) + H(I,J,K-1) * ANB(I,J,K,5)
  240 IF (K.EQ.NZ) GO TO 250
      DD(J) = DD(J) + H(I,J,K+1) * ANB(I,J,K,6)
  250 DD(J) = DD(J) + B(I,J,K)
      UU(J) = H(I,J,K)
  200 CONTINUE
      CALL THOMAS (NY)
      DO 260 J = 1, NY
      HALT = H(I,J,K)
      H(I,J,K) = H(I,J,K) + OMEGA * (UU(J) - H(I,J,K))
      HNEU = H(I,J,K)
      ERR = ABS(HNEU - HALT)
      IF (ERR.GT.FEHL) FEHL = ERR
      IF (HALT.LT.HO.AND.HNEU.GT.HO) CALL DELTAH (I,J,K)
      IF (HNEU.LT.HO) CALL DELTAH (I,J,K)
  260 CONTINUE
  270 CONTINUE
C
C *** Saeulenberechnung ************************************************
C
      IF (NZ.EQ.1) GO TO 370
      CALL RICHTG (M,JANF,JEND,JPLUS,NY,1)
      DO 360 J = JANF, JEND, JPLUS
      CALL RICHTG (J,IANF,IEND,IPLUS,NX,1)
      DO 360 I = IANF, IEND, IPLUS
      DO 300 K = 1, NZ
      AA(K) = - ANB(I,J,K,5)
      CC(K) = - ANB(I,J,K,6)
      BB(K) = AP1(I,J,K)
      DD(K) = 0.
      IF (I.EQ.1)  GO TO 320
      DD(K) =         H(I-1,J,K) * ANB(I,J,K,1)
  320 IF (I.EQ.NX) GO TO 330
      DD(K) = DD(K) + H(I+1,J,K) * ANB(I,J,K,2)
  330 IF (J.EQ.1)  GO TO 340
      DD(K) = DD(K) + H(I,J-1,K) * ANB(I,J,K,3)
  340 IF (J.EQ.NY) GO TO 350
      DD(K) = DD(K) + H(I,J+1,K) * ANB(I,J,K,4)
  350 DD(K) = DD(K) + B(I,J,K)
      UU(K) = H(I,J,K)
  300 CONTINUE
      CALL THOMAS (NZ)
      DO 360 K = 1, NZ
      HO = HOENN - ZKOR(K) - DIVZ(K,2) + DELTAZ(K)
      HALT = H(I,J,K)
      H(I,J,K) = H(I,J,K) + OMEGA * (UU(K) - H(I,J,K))
      HNEU = H(I,J,K)
      ERR = ABS(HNEU - HALT)
      IF (ERR.GT.FEHL) FEHL = ERR
      IF (HALT.LT.HO.AND.HNEU.GT.HO) CALL DELTAH (I,J,K)
      IF (HNEU.LT.HO) CALL DELTAH (I,J,K)
  360 CONTINUE
  370 CONTINUE
      IF (IECHO.GE.1) WRITE (1,30) NIT,FEHL
      IF (FEHL.GT.FEHLH.AND.NIT.LT.ILOOP) GO TO 1000
      FEHLER = FEHL
      IF (ISOR.EQ.2) THEN
         ALFA = ALFAHY
         CALL OMEGAT(FEHL,OMEGA,ALFA)
         IF (ISOR.NE.1) THEN
            CALL KOEFFH
            OMGH = -OMGH
            GO TO 90
         END IF
      END IF
   30 FORMAT(1H+,' Iteration Nummer ==> ',I3,' === Iterationsfehler = ',
     &       F11.6)
      RETURN
      END
C&IADITP
C **********************************************************************
C     Version 21071988  Subroutine IADITP
C **********************************************************************
C
C *** Subroutine IADITP Temperaturberechnung nach dem IADI-Verfahren ***
C
      SUBROUTINE IADITP
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      DOUBLE PRECISION UU,AA,BB,CC,DD,ERR,FEHL
      DOUBLE PRECISION T,T0,STMP,TT,TALT
      CHARACTER FLAG*4,UFLS*4
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      DIMENSION UU(IMAX),AA(IMAX),BB(IMAX),CC(IMAX),DD(IMAX)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IADI/UU,AA,BB,CC,DD
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /TEMP/T,T0,STMP
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
   90 OMEGA = - OMGT
      IF (IECHO.GE.1) CALL ROUTIN ('IADITP')
      IAUSOP = 1
      NIT = 0
      M = 0
      IF (IECHO.GE.1) WRITE (1,*)
 1000 NIT = NIT + 1
      FEHL = 0.
      M = M + 1
C
C *** Zeilenberechnung *************************************************
C
      IF (NX.EQ.1) GO TO 170
      CALL RICHTG (M,KANF,KEND,KPLUS,NZ,1)
      DO 160 K = KANF, KEND, KPLUS
      N = K
      IF (NZ.EQ.1) N = M
      CALL RICHTG (N,JANF,JEND,JPLUS,NY,1)
      DO 160 J = JANF, JEND, JPLUS
      DO 100 I = 1, NX
      AA(I) = - ANB(I,J,K,1)
      CC(I) = - ANB(I,J,K,2)
      BB(I) = AP1(I,J,K)
      DD(I) = 0.
      IF (J.EQ.1)  GO TO 120
      DD(I) =         T(I,J-1,K) * ANB(I,J,K,3)
  120 IF (J.EQ.NY) GO TO 130
      DD(I) = DD(I) + T(I,J+1,K) * ANB(I,J,K,4)
  130 IF (K.EQ.1)  GO TO 140
      DD(I) = DD(I) + T(I,J,K-1) * ANB(I,J,K,5)
  140 IF (K.EQ.NZ) GO TO 150
      DD(I) = DD(I) + T(I,J,K+1) * ANB(I,J,K,6)
  150 DD(I) = DD(I) + B(I,J,K)
      UU(I) = T(I,J,K)
  100 CONTINUE
      CALL THOMAS (NX)
      DO 160 I = 1, NX
      TALT = T(I,J,K)      
      T(I,J,K) = T(I,J,K) + OMEGA * (UU(I) - T(I,J,K))
      IF (IFROST.GE.1) CALL PHATST (I,J,K,TALT,T(I,J,K))
      ERR = DABS(T(I,J,K) - TALT)
      IF (ERR.GT.FEHL) FEHL = ERR
  160 CONTINUE
  170 CONTINUE
C
C *** Spaltenberechnung ************************************************
C
      IF (NY.EQ.1) GO TO 270
      CALL RICHTG (M,IANF,IEND,IPLUS,NX,1)
      DO 260 I = IANF, IEND, IPLUS
      CALL RICHTG (I,KANF,KEND,KPLUS,NZ,1)
      DO 260 K = KANF, KEND, KPLUS
      DO 200 J = 1, NY
      AA(J) = - ANB(I,J,K,3)
      CC(J) = - ANB(I,J,K,4)
      BB(J) = AP1(I,J,K)
      DD(J) = 0.
      IF (I.EQ.1)  GO TO 220
      DD(J) =         T(I-1,J,K) * ANB(I,J,K,1)
  220 IF (I.EQ.NX) GO TO 230
      DD(J) = DD(J) + T(I+1,J,K) * ANB(I,J,K,2)
  230 IF (K.EQ.1)  GO TO 240
      DD(J) = DD(J) + T(I,J,K-1) * ANB(I,J,K,5)
  240 IF (K.EQ.NZ) GO TO 250
      DD(J) = DD(J) + T(I,J,K+1) * ANB(I,J,K,6)
  250 DD(J) = DD(J) + B(I,J,K)
      UU(J) = T(I,J,K)
  200 CONTINUE
      CALL THOMAS (NY)
      DO 260 J = 1, NY
      TALT = T(I,J,K)      
      T(I,J,K) = T(I,J,K) + OMEGA * (UU(J) - T(I,J,K))
      IF (IFROST.GE.1) CALL PHATST (I,J,K,TALT,T(I,J,K))
      ERR = DABS(T(I,J,K) - TALT)
      IF (ERR.GT.FEHL) FEHL = ERR
  260 CONTINUE
  270 CONTINUE
C
C *** Saeulenberechnung ************************************************
C
      IF (NZ.EQ.1) GO TO 370
      CALL RICHTG (M,JANF,JEND,JPLUS,NY,1)
      DO 360 J = JANF, JEND, JPLUS
      CALL RICHTG (J,IANF,IEND,IPLUS,NX,1)
      DO 360 I = IANF, IEND, IPLUS
      DO 300 K = 1, NZ
      AA(K) = - ANB(I,J,K,5)
      CC(K) = - ANB(I,J,K,6)
      BB(K) = AP1(I,J,K)
      DD(K) = 0.
      IF (I.EQ.1)  GO TO 320
      DD(K) =         T(I-1,J,K) * ANB(I,J,K,1)
  320 IF (I.EQ.NX) GO TO 330
      DD(K) = DD(K) + T(I+1,J,K) * ANB(I,J,K,2)
  330 IF (J.EQ.1)  GO TO 340
      DD(K) = DD(K) + T(I,J-1,K) * ANB(I,J,K,3)
  340 IF (J.EQ.NY) GO TO 350
      DD(K) = DD(K) + T(I,J+1,K) * ANB(I,J,K,4)
  350 DD(K) = DD(K) + B(I,J,K)
      UU(K) = T(I,J,K)
  300 CONTINUE
      CALL THOMAS (NZ)
      DO 360 K = 1, NZ
      TALT = T(I,J,K)      
      T(I,J,K) = T(I,J,K) + OMEGA * (UU(K) - T(I,J,K))
      IF (IFROST.GE.1) CALL PHATST (I,J,K,TALT,T(I,J,K))
      ERR = DABS(T(I,J,K) - TALT)
      IF (ERR.GT.FEHL) FEHL = ERR
  360 CONTINUE
  370 CONTINUE
      IF (IWCP.GE.3) CALL KOEFFT (1,1,1,NX,NY,NZ)
      IF (IECHO.GE.1) WRITE (1,30) NIT,FEHL
      IF (FEHL.GT.FEHLT.AND.NIT.LT.ILOOP) GO TO 1000
      FEHLER = FEHL
      IF (ISOR.EQ.1) THEN
         ALFA = ALFATP
         CALL OMEGAT(FEHL,OMEGA,ALFA)
         IF (ISOR.NE.0) THEN
            OMGT = -OMGT
            GO TO 90
         END IF
      END IF
   30 FORMAT(1H+,' Iteration Nummer ==> ',I3,' === Iterationsfehler = ',
     &       F11.6)
      RETURN
      END
C&INFINT
C **********************************************************************
C     Version 18061987  Subroutine INFINT
C **********************************************************************
C
C *** Subroutine INFINT Berechnung der Interface-Wichtungsfaktoren *****
C
      SUBROUTINE INFINT
      PARAMETER (IW=1,IE=2,IN=1,IS=2,IT=1,IB=2)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
C
      IF (IECHO.GE.1) CALL ROUTIN ('INFINT')
C
      IF (IVOLDF.EQ.0) GO TO 40
C
C *** IVOLDF  =  1    =>  Interfaceflaechen liegen auf halber Strecke
C                         zwischen den Knotenpunkten
C
      DO 10 I = 1, NX1
         FX(I) = 0.5
   10 CONTINUE
      DO 20 J = 1, NY1
         FY(J) = 0.5
   20 CONTINUE
      DO 30 K = 1, NZ1
         FZ(K) = 0.5
   30 CONTINUE
      RETURN
C
C *** IVOLDF  =  0    =>  Knotenpunkt liegt im geometrischen Zentrum **
C
   40 CONTINUE
      DO 50 I = 1, NX1
         FX(I) = DIVX(I,IE) / DIFX(I)
   50 CONTINUE
      DO 60 J = 1, NY1
         FY(J) = DIVY(J,IS) / DIFY(J)
   60 CONTINUE
      DO 70 K = 1, NZ1
         FZ(K) = DIVZ(K,IB) / DIFZ(K)
   70 CONTINUE
      RETURN
      END
C&INFORM
C **********************************************************************
C     Version 11061987  Subroutine INFORM
C **********************************************************************
C
C *** Subroutine INFORM Einlesen des Problemtitels und Timesteps *******
C
      SUBROUTINE INFORM
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELV
      CHARACTER ZEIT*3,ZFLAG*3,FORMIN*20,TITEL*80,TEXT*40,FORM*9
      CHARACTER EIN*20,AUS*20,OBSFIL*20,DATOP*20,CARD*3
      DIMENSION ZEIT(4)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /ENER/SC,SP,FRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /INF5/IVIS,IWRO
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /ISOP/IXISO,IYISO,IZISO,ISO1,IMSBIN
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PAR4/DTW,DTW2,DWAN,DTWL(3)
      COMMON /TEMP/T,T0,STMP
      DATA ZEIT/'SEK','MIN','STU','TAG'/
      AUS = 'CON'
      EIN = 'TRADAT'
      OPEN(1,FILE=AUS,STATUS='OLD')
      CALL HEADER(1)
      GO TO 2000
 1000 WRITE (1,220)
      READ (*,20) EIN
 2000 OPEN(5,FILE=EIN,STATUS='OLD',ERR=1000)
C
C     UNIT  1  Bildschirmausgabe
C     UNIT  5  Eingabedatei
C     UNIT  6  Ergebnisdatei
C     UNIT  7  optionale Ausgabedatei fuer Beobachtungsknoten
C     UNIT  8  optionale Eingabedatei der Zusatzdaten
C     UNIT  9  optionale Ein-/Ausgabedatei fuer einen Warmstart
C
      CARD = '1'
      READ (5,10) TITEL
      CARD = '3'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) IXISO,IYISO,IZISO,IMSBIN
      CARD = '5'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) IOBS,IDATOP,LISDAT,OBSFIL,
     &                                AUS,DATOP
C
C     IOBS = 0    ==> OBSFIL wird nicht eroeffnet
C     IOBS > 0    ==> OBSFIL wird mit Knotentemperaturen beschrieben
C
C     IDATOP = 0  ==> es werden keine zusaetzlichen Daten angefordert
C     IDATOP = 1  ==> es werden Daten von File DATOP angefordert
C
C     LISDAT gibt an, in welchem Intervall zusaetzliche Daten von File
C            DATOP angefordert werden.
C            z.B. LISDAT = 1 ==> nach jedem Zeitschritt
C                 LISDAT = 9 ==> nach jedem neunten Zeitschritt usw.
C
      IAUS = 6
      IF (IDATOP.EQ.1) THEN
        OPEN(8,FILE=DATOP,STATUS='OLD',ERR=500)
        GO TO 510
  500   WRITE (1,610) DATOP
        STOP
      END IF
  510 IF (IOBS.GT.0) OPEN(7,FILE=OBSFIL)
C
C *** Eingabe von TERMINAL fuer File AUS bewirkt Bildschirmausgabe ****
C
      IF (AUS.EQ.'TERMINAL') THEN
         IAUS = 1
         GO TO 250
      END IF
      OPEN(IAUS,FILE=AUS,STATUS='OLD',ERR=210)
      GO TO 250
  210 OPEN(IAUS,FILE=AUS,STATUS='NEW')
  250 CARD = '7'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) IZEIT,ILOOP,IEIN,IAUSOP,INPOP,
     &                                IDRU,ISTLAE,ZFLAG,DZF,FEHLT,Z
      IF (Z.GT.0.) ZZZZ = Z
C
C     IAUSOP = 1   ==> nur Temperaturprofile
C     IAUSOP = 2   ==> Temperatur- und Eingangsdatenprofile
C     IAUSOP = 3   ==> alle Eingangsdaten + Temperaturprofile
C
      CARD = '9'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) FLURAB,MODEL,IENER,ISTOP,IDZTST,
     &                                IWARMS,IWSDAT,IDSTOP
C
C     MODEL = 1   ==>  Maximaleinfluss des Porenraumes
C     MODEL = 2   ==>  Minimaleinfluss des Porenraumes
C
C     IDZTST = 0  ==>  Zeitschrittlaenge wird nur getestet
C     IDZTST = 1  ==>  Zeitschrittlaenge wird getestet, ggf. verkuerzt
C
C     IWARMS = 0  ==>  "Kaltstart"
C     IWARMS = 1  ==>  "Warmstart", d.h. es werden die bereits
C                       berechneten Temperaturen des letzten Ergebnis-
C                       druckes einer vorherigen Simulation aus Aus-
C                       gangsbasis benutzt
C
C     IWSDAT = 0  ==>   "Warmstartdaten" - Ausgabe wird unterdrueckt
C     IWSDAT = 1  ==>   es werden parallel zu jedem Ergebnisausdruck
C                       alle berechneten Temperaturen auf die Datei
C                       TRADWS geschrieben; diese Datei wird bei einer
C                       darauffolgenden Simulation gelesen, sofern
C                       IWARMS = 1
C
C     IDSTOP = 0  ==>   Simulation wird auch bei verletzten Dis-
C                       kretisierungsvorschriften fortgesetzt
C     IDSTOP = 1  ==>   Simulation wird bei verletzten Dis-
C                       kretisierungsvorschriften vorzeitig abgebrochen
C
C     IOBS        ==>   Anzahl der Beobachtungsknoten
C
      CARD = '11'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) ALFATP,OMGT,IVOLDF,IPECL,IDIF,
     &                                IFROST,IECHO,IALTER,IWCP,ISOR
      IF (IWCP.EQ.0) THEN
         CPW    = 0.
         CPE    = 0.
         CPL    = 0.
         WLW    = 0.
         WLE    = 0.
         WLL    = 0.
         RHOW   = 0.
         RHOE   = 0.
         RHOL   = 0.
         SENTHA = 0.
         DTW    = 0.1
         DWAN   = 0.001
      END IF
      IF (IWCP.EQ.1) THEN
         CPW    = 4200.
         CPE    = 2114.
         CPL    = 0.
         WLW    = 0.57
         WLE    = 2.25
         WLL    = 0.025
         RHOW   = 1000.
         RHOE   =  917.
         RHOL   =  0.
         SENTHA = 6030. / 18.0153 * 1000.
         DTW    = 0.1
         DWAN   = 0.001
C
C     Waermekapazitaet von Luft:               0  J/kg*K
C     Waermekapazitaet von Wasser:          4200  J/kg*K
C     Waermekapazitaet von Eis:             2114  J/kg*K
C     Waermeleitfaehigkeit von Luft:       0.025  W/m*K
C     Waermeleitfaehigkeit von Wasser:     0.570  W/m*K
C     Waermeleitfaehigkeit von Eis:        2.250  W/m*K
C     Dichte von Luft:                         0  kg/cbm
C     Dichte von Wasser:                    1000  kg/cbm
C     Dichte von Eis:                        917  kg/cbm
C     Schmelzenthalpie von reinem Wasser:   6030  J/mol
C     Molekulargewicht von Wasser        18.0153  g/mol   
C     DTW bei Neuberechnung der Waerme-
C     kapazitaet von teilgefrorenem Wasser   0.1  K
C     DWAN maximale Aenderung des unge-
C     frorenen Wasseranteiles                0.1  %
C     
C     vergl. Anhang 1 der Dokumentation
C
      END IF
      IF (IWCP.GE.2) THEN
         CARD = '11b'
         READ (5,20,END=900) FORMIN
         READ (5,FORMIN,ERR=800,END=900) CPW,CPE,CPL,WLW,WLE,WLL,RHOW,
     &                                   RHOE,RHOL,SENTHA,DTW,DWAN
C
C *** Modelle fuer die P/T - Abhaengigkeit der WLF *********************
C
         IF (IWCP.GE.3) THEN
            CARD = '11d'
            READ (5,20,END=900) FORMIN
            IDT = 2
            IF (IWCP.LT.5) IDT = 3
            READ (5,FORMIN,ERR=800,END=900) (DTWL(I),I=1,IDT)
         END IF
      END IF
C
C *** NB: SENTHA in Joule/kg eingeben **********************************
C
      DTW2 = DTW / 2.      
C
C *** Bestimmung des Loesungsschema der Temperaturberechnung ***********
C
C     ALFATP = 0         ==>     Explizit - Schema
C     1 > ALFATP > 0     ==>     Implizit - Schema
C     ALFATP = 0.5       ==>     Crank - Nicolson - Schema
C     ALFATP = 1         ==>     Vollimplizit - Schema
C *** Iterationsverfahren der Temperaturberechnung *********************
C
C     OMGT =  0.0        ==>     Default - (IADI - Verfahren)
C     OMGT < -1.0        ==>     Line - Succesive Over-Relaxation
C     0.0 > OMGT > -1.0  ==>     Line - Succesive Under-Relaxation
C     OMGT = -1.0        ==>     IADI - Verfahren
C     OMGT =  1.0        ==>     Gauss - Seidel - Verfahren
C     OMGT >  1.0        ==>     Successive Over-Relaxation
C     0.0 < OMGT <  1.0  ==>     Successive Under-Relaxation
C
C *** Berechnungsschema der PECLET - Wichtungsfunktion *****************
C
C     IPECL = 0          ==>     Default - (Exponential - Schema)
C     IPECL = 1          ==>     Zentrale Differenzen
C     IPECL = 2          ==>     Upwind - Schema
C     IPECL = 3          ==>     Hybrid - Schema
C     IPECL = 4          ==>     Power law - Schema
C     IPECL = 5          ==>     Exponential - Schema
C
C
C     IDIF =  0          ==>     reine Konduktion
C     IDIF =  1          ==>     Diffussion und Konvektion
C
C     IFROST = 0         ==>     Phasenaenderung wird ignoriert
C     IFROST > 0         ==>     Phasenaenderung wird beruecksichtigt:
C     IFROST = 1         ==>     STMP(K) = 0 Grad Celsius
C     IFROST = 2         ==>     STMP(K) wird in Subroutine TAUPKT
C                                berechnet (noch nicht moeglich)
C     IFROST = 3         ==>     STMP(K) wird von der Eingabedatei
C                                angefordert (Karten 11a und 11b)
C
C     IECHO  =-1         ==>     kein Bildschirmprotokoll
C     IECHO  = 0         ==>     nur Zeit wird ausgegeben
C     IECHO  = 1         ==>     Bildschirmprotokoll aktiviert, kompakt
C     IECHO  = 2         ==>     Bildschirmprotokoll aktiviert, komplett
C
C     IALTER = 0         ==>     Iteration in aufsteigender Reihenfolge
C     IALTER = 1         ==>     Iteration in alternierender Reihenfolge
C
C     IWCP   = 0         ==>     Fluideigenschaften alle 0
C     IWCP   = 1         ==>     Fluideigenschaften gegeben, s.o.
C     IWCP   = 2         ==>     Fluideigenschaften werden eingelesen
C     IWCP   = 3         ==>     wie 2, jedoch WLKG temperaturabhaengig
C                                (polynomische Approximation)
C     IWCP   = 4         ==>     wie 2, jedoch WLKG temperaturabhaengig
C                                (exponentielle Approximation)
C                                
C     ISOR   = 0         ==>     OMEGA - Wert wird nicht getestet
C     ISOR   = 1         ==>     OMEGA - Wert fuer OMGT wird getestet
C
C     IENER  = 0         ==>     Energibilanzierung wird ignoriert
C     IENER  = 1         ==>     Energibilanzierung wird aktiviert
C
C     ISTOP  = 0         ==>     Berechnung nicht abbrechen
C     ISTOP  = 1         ==>     Berechnung beim Gleichgewichtszustand
C                                abbrechen (NIT = 1 und FEHLER < FEHLT)
C
C *** Bestimmung der Lage des Knotenpunktes innerhalb der Zellen *******
C
C     IVOLDF  =  0    =>  Knotenpunkt liegt im geometrischen Zentrum
C     IVOLDF  =  1    =>  Interfaceflaechen liegen auf halber Strecke
C                         zwischen den Knotenpunkten
C
      CARD = '13'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) BASIS,HOENN,ALFAHY,OMGH,FEHLH,
     &                                IGWF,IVIS,IWRO
C
C *** falls Stroemungsfeld aus der Durchlaessigkeit und der Potential-
C     differenz berechnet werden soll ...
C
C     IGWF    =  0    =>  Stroemungsfeld gegeben
C     IGWF    =  1    =>  Stroemungsfeld wird berechnet
C     IGWF    =  2    =>  es wird nur das Stroemungsfeld berechnet
C     BASIS               Aquiferbasis in Meter ueber NN
C     HOENN               Hoehe der Erdoberflaeche in Meter ueber NN
C     IVIS    =  0    =>  Viskositaetsaenderung des Wassers ignorieren
C     IVIS    =  1    =>  Viskositaetsaenderung des Wassers wird in
C                         Abhaengigkeit der Temperatur berechnet
C     IWRO    =  0    =>  Dichte des Wassers konstant
C     IWRO    =  1    =>  Dichte des Wassers wird in Abhaengigkeit
C                         der Temperatur berechnet
C
C *** Bestimmung des Loesungsschema der Stroemungsberechnung ***********
C
C     ALFAHY = 0         ==>     Explizit - Schema
C     1 > ALFAHY > 0     ==>     Implizit - Schema
C     ALFAHY = 0.5       ==>     Crank - Nicolson - Schema
C     ALFAHY = 1         ==>     Vollimplizit - Schema
C
C *** Iterationsverfahren der Stroemungsberechnung *********************
C
C     OMGH =  0.0        ==>     Default - (IADI - Verfahren)
C     OMGH < -1.0        ==>     Line - Succesive Over-Relaxation
C     0.0 > OMGH > -1.0  ==>     Line - Succesive Under-Relaxation
C     OMGH = -1.0        ==>     IADI - Verfahren
C     OMGH =  1.0        ==>     Gauss - Seidel - Verfahren
C     OMGH >  1.0        ==>     Successive Over-Relaxation
C     0.0 < OMGH <  1.0  ==>     Successive Under-Relaxation
C
C     UNIT 11  optionale Ausgabedatei fuer Y - Z Isolinienplots (T)
C     UNIT 12  optionale Ausgabedatei fuer X - Z Isolinienplots (T)
C     UNIT 13  optionale Ausgabedatei fuer X - Y Isolinienplots (T)
C     UNIT 21  optionale Ausgabedatei fuer Y - Z Isolinienplots (H)
C     UNIT 22  optionale Ausgabedatei fuer X - Z Isolinienplots (H)
C     UNIT 23  optionale Ausgabedatei fuer X - Y Isolinienplots (H)
C
C     IMSBIN = 0         ==>     formatierte Ausgabe fuer Postprozessor
C     IMSBIN = 0         ==>     MS - Binaerformat fuer Postprozessor
C
      FORM = 'FORMATTED'
      IF (IMSBIN.EQ.1) FORM = 'BINARY'
      IF (IGWF.LE.1) THEN
         IF (IXISO.EQ.1) OPEN(11,FILE='TEMPYZ',FORM=FORM)
         IF (IYISO.EQ.1) OPEN(12,FILE='TEMPXZ',FORM=FORM)
         IF (IZISO.EQ.1) OPEN(13,FILE='TEMPXY',FORM=FORM)
      END IF
      IF (IGWF.GE.1) THEN
         IF (IXISO.EQ.1) OPEN(21,FILE='PIEZYZ',FORM=FORM)
         IF (IYISO.EQ.1) OPEN(22,FILE='PIEZXZ',FORM=FORM)
         IF (IZISO.EQ.1) OPEN(23,FILE='PIEZXY',FORM=FORM)
      END IF
C
C *** Bestimmung der bei IAUSOP < 3 zu druckenden Profilschnitte *******
C
      CARD = '15'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) IPROX,IPROY,IPROZ
      IF (ZFLAG.EQ.ZEIT(1)) DZMF = 1.
      IF (ZFLAG.EQ.ZEIT(2)) DZMF = 60.
      IF (ZFLAG.EQ.ZEIT(3)) DZMF = 3600.
      IF (ZFLAG.EQ.ZEIT(4)) DZMF = 86400.
      DZEIT = ISTLAE * DZMF
      IF (DZF.LE.0.) DZF = 1.
      DSIM = DZEIT / 3600.
      DZT  = DSIM
      DO 690 I = 1, IZEIT - 1
         DZT  = DZT * DZF
         DSIM = DSIM + DZT
  690 CONTINUE
      DMIN = DZEIT / 60.
      IF (IOBS.GT.0) THEN
         CARD = '15b'
         READ (5,20,END=900) FORMIN
         DO 700 I = 1, IOBS
         READ (5,FORMIN,ERR=800,END=900) IXOBS(I),IYOBS(I),IZOBS(I)
  700    CONTINUE
      END IF
      CARD = '17'
      READ (5,20,END=900) FORMIN
      READ (5,FORMIN,ERR=800,END=900) NX,NY,NZ
      IF (NX.GT.IX.OR.NY.GT.IY.OR.NZ.GT.IZ.OR.MIN0(NX,NY,NZ).LT.1) THEN
         WRITE (1,175)
         WRITE (1,180) NX,NY,NZ
         WRITE (1,185) IX,IY,IZ
         STOP ' Bitte Dimensionierung anpassen !'
      END IF
      IF ((IGWF.GE.1.AND.IP2.EQ.0).OR.(IGWF.LE.1.AND.IP1.EQ.0)) THEN
         IF (IP1.EQ.0) STOP ' Nur Stroemungsberechnung moeglich IP1 =0)'
         IF (IP2.EQ.0) STOP ' Nur Temperaturberechnung moeglich IP2 =0)'
      END IF
      IF (IFROST.EQ.1.AND.IGWF.LE.1) THEN
C
C *** Schmelztemperatur des Fluids einheitlich konstant 0 Grad Celsius *
C        
         DO 61 K = 1, NZ
            STMP(K) = CELV(0.0D00)
   61    CONTINUE
      END IF
C
C *** Einlesen der Schmelztemperaturen *********************************
C
      IF (IFROST.EQ.3.AND.IGWF.LE.1) THEN
         READ (5,20,END=900) FORMIN
         CARD = '17b'
         READ (5,FORMIN,ERR=800,END=900) (STMP(K),K = 1, NZ)
         DO 70 K = 1, NZ
            STMP(K) = CELV(STMP(K))
   70    CONTINUE
      END IF
C
C *** Einlesen der Gefriermodelle ... **********************************
C
      IF (IFROST.GT.0.AND.IGWF.LE.1) THEN
         READ (5,20,END=900) FORMIN
         CARD = '17d'
         READ (5,FORMIN,ERR=800,END=900) (IFRO(K),K = 1, NZ)
         READ (5,20,END=900) FORMIN
C
C     Gefriermodell 1:  Y = FRO(1) * EXP(FRO(2) * X) + FRO(3)          *
C     ----------------
C     es bedeuten:          Y = Anteil de ungefrorenen Wassers
C                           X = Temperatur in K unter Schmelztemperatur
C
         DO 71 K = 1, NZ
         IF (IFRO(K).EQ.1) THEN         
            CARD = '17f'
            READ (5,FORMIN,ERR=800,END=900) (FRO(K,L),L = 1, 3)
         END IF
   71    CONTINUE
      END IF
      NX1 = NX - 1
      NY1 = NY - 1
      NZ1 = NZ - 1
C
C *** Ausgabe der globalen Eingabeparameter ****************************
C
      IF (IAUS.EQ.6) CALL HEADER(IAUS)
      WRITE (IAUS,15) TITEL
      WRITE (IAUS,600)
      WRITE (IAUS,180) NX,NY,NZ
      WRITE (IAUS,185) IX,IY,IZ
      IF (DZF.EQ.1.) WRITE (IAUS,30) IZEIT,DMIN,DSIM
      IF (DZF.NE.1.) WRITE (IAUS,35) IZEIT,DMIN,DZF,DSIM
      IF (IOBS.GT.0) THEN
         WRITE (IAUS,50) IOBS
         DO 710 I = 1, IOBS
            WRITE (IAUS,55) IXOBS(I),IYOBS(I),IZOBS(I)
  710    CONTINUE
         WRITE (IAUS,60) OBSFIL
      END IF
      IF (IGWF.EQ.2) GO TO 520
      TEXT = 'Temperatur'
      WRITE (IAUS,400) TEXT
      IF (OMGT.EQ.0.) OMGT = -1.
      IF (OMGT.EQ.1.) WRITE (IAUS,420)
      IF (OMGT.GT.0..AND.OMGT.NE.1.) WRITE (IAUS,430) OMGT
      IF (OMGT.EQ.-1.) WRITE (IAUS,440)
      IF (OMGT.LT.0..AND.OMGT.NE.-1.) WRITE (IAUS,450) -OMGT
      TEXT = 'Grad Kelvin'
      WRITE (IAUS,160) FEHLT,TEXT
      TEXT = 'ITERAT'
      IF (OMGT.LT.0.) TEXT = 'IADITP'
      WRITE (IAUS,170) ILOOP,TEXT
      IF (OMGT.GT.0.AND.IALTER.EQ.0) WRITE (IAUS,340)
      IF (OMGT.GT.0.AND.IALTER.EQ.1) WRITE (IAUS,350)
      IF (ALFATP.EQ.0.) TEXT = 'Explizit Schema'
      IF (ALFATP.GT.0..AND.ALFATP.NE.1..AND.ALFATP.NE.0.5)
     &   TEXT = 'Implizit Schema'
      IF (ALFATP.EQ.0.5) TEXT = 'Crank - Nicolson - Schema'
      IF (ALFATP.EQ.1.) TEXT = 'Vollimplizit Schema'
      WRITE (IAUS,40) TEXT,ALFATP
  520 IF (IGWF.EQ.0) GO TO 525
      TEXT = 'Stroemungs'
      WRITE (IAUS,400) TEXT
      IF (OMGH.EQ.0.) OMGH = -1.
      IF (OMGH.EQ.1.) WRITE (IAUS,420)
      IF (OMGH.GT.0..AND.OMGH.NE.1.) WRITE (IAUS,430) OMGH
      IF (OMGH.EQ.-1.) WRITE (IAUS,440)
      IF (OMGH.LT.0..AND.OMGH.NE.-1.) WRITE (IAUS,450) -OMGH
      TEXT = 'Meter'
      WRITE (IAUS,160) FEHLH,TEXT
      TEXT = 'ITERAH'
      IF (OMGH.LT.0.) TEXT = 'IADIST'
      WRITE (IAUS,170) ILOOP,TEXT
      IF (OMGH.GT.0.AND.IALTER.EQ.0) WRITE (IAUS,340)
      IF (OMGH.GT.0.AND.IALTER.EQ.1) WRITE (IAUS,350)
      IF (ALFAHY.EQ.0.) TEXT = 'Explizit Schema'
      IF (ALFAHY.GT.0..AND.ALFAHY.NE.1..AND.ALFAHY.NE.0.5)
     &   TEXT = 'Implizit Schema'
      IF (ALFAHY.EQ.0.5) TEXT = 'Crank - Nicolson - Schema'
      IF (ALFAHY.EQ.1.) TEXT = 'Vollimplizit Schema'
      WRITE (IAUS,40) TEXT,ALFAHY
  525 IF (IGWF.EQ.2) GO TO 535
      IF (IDIF.EQ.0) GO TO 530
      WRITE (IAUS,310)
      IF (IPECL.EQ.0) IPECL = 5
      IF (IPECL.EQ.1) TEXT = 'durch Zentrale Differenzen'
      IF (IPECL.EQ.2) TEXT = 'nach dem Upwind - Schema'
      IF (IPECL.EQ.3) TEXT = 'nach dem Hybrid - Schema'
      IF (IPECL.EQ.4) TEXT = 'nach dem Power law - Schema'
      IF (IPECL.EQ.5) TEXT = 'nach dem Exponential - Schema'
      WRITE (IAUS,110) TEXT
  530 IF (IDIF.EQ.0) WRITE (IAUS,300)
      IF (IFROST.EQ.0) TEXT = 'ignoriert'
      IF (IFROST.GE.1) TEXT = 'beruecksichtigt'
      WRITE (IAUS,320) TEXT
      WRITE (IAUS,360) CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA,
     &                 DTW,DWAN * 100.
  535 IF (IVOLDF.EQ.0) WRITE (IAUS,90)
      IF (IVOLDF.EQ.1) WRITE (IAUS,100)
      RETURN
  800 WRITE (1,*) 'fehlerhaftes Datenformat in Karte ',CARD
      STOP 'Bitte Datei ueberpruefen!'
  900 WRITE (1,*) 'unerwartet Dateiende erreicht nach Karte ',CARD
      STOP 'Bitte Datei ergaenzen!'
   10 FORMAT(A80)
   15 FORMAT(1H ,A80)
   20 FORMAT(A20)
   30 FORMAT(/,I4,' Zeitschritte ',F7.1,' Minuten Zeitschrittlaenge ',
     &       F6.1,' Stunden Simulation')
   35 FORMAT(/,I4,' Zeitschritte ',F8.2,' Minuten Anfangszeitschritt',
     &       'laenge',/,F7.4,' Zeitschrittfaktor  ',F7.1,' Stunden ',
     &       'Simulation')
   40 FORMAT(/,' Loesung der DGL nach dem ',A26,
     &         ' -  Wichtungsfaktor => ',F4.2)
   50 FORMAT(/,' Die Temperaturen bzw. Piezometerhoehen folgender ',
     &       I2,' Knoten:',//,T20,'   X      Y      Z   ',/,
     &       T20,21(1H-))
   55 FORMAT(T17,3I7)
   60 FORMAT(T20,21(1H-),//,' werden auf der Datei ',A14,' ausgegeben.')
   90 FORMAT(/,' Knotenpunkte liegen im geometrischen Zentrum der Zellen
     &')
  100 FORMAT(/,' Zellengrenzen liegen auf halber Strecke zwischen den Kn
     &oten')
  110 FORMAT(/,' Berechnung der Peclet-Wichtungsfunktion ',A30)
  160 FORMAT(/,' erlaubter Iterationsfehler  +/- ',F9.7,1X,A11)
  170 FORMAT(/,' jedoch maximal ',I4,' Durchlaeufe von Subroutine ',A6)
  175 FORMAT(' Konflikt in der Knotendimensionierung:',/,1H ,38(1H=))
  180 FORMAT(/,' Anzahl der Knoten:    NX  ==>  ',I4,'  NY  ==>  ',I4,
     &'  NZ  ==>  ',I4,/)
  185 FORMAT(/,' Programmdimensionen:  IX  ==>  ',I4,'  IY  ==>  ',I4,
     &'  IZ  ==>  ',I4,/)
  220 FORMAT( ' Eingabedatenfile eingeben    ==> ',\)
  300 FORMAT(/,' reines Konduktionssproblem')
  310 FORMAT(/,' Diffusion und Konvektion werden beruecksichtigt')
  320 FORMAT(/,' Phasenaenderung von Wasser wird ',A40)
  340 FORMAT(/,' Iteration erfolgt in aufsteigender Reihenfolge')
  350 FORMAT(/,' Iteration erfolgt in alternierenden Richtungen')
  360 FORMAT(/,' Eigenschaften des Fluids:  fluessig       fest     ',
     &         ' gasfoermig',/, 1X,63(1H-),/,
     &         ' Waermekapazitaet:',      T25,3(5X,F6.1),' J/kg*K',/,
     &         ' Waermeleitfaehigkeit:',  T25,3(5X,F6.3),' W/m*K',/,
     &         ' Dichte:',                T25,3(5X,F6.1),' kg/cbm',/,
     &         ' Schmelzenthalpie:',      T26,1PE10.3,' J/kg',//,
     &         ' T - Schr. bei Frost:',   T30,F6.4,' K',/,
     &         ' max. Aender. Eis DWAN:', T30,F6.2,' %',/)
  400 FORMAT(/,' Iterationsverfahren der ',A10,'berechnung:',
     &       /,1H ,45(1H-))
  420 FORMAT(/,' Gauss - Seidel - Punkt fuer Punkt')
  430 FORMAT(/,' Successive Over/Under-Relaxation - Punkt fuer Punkt -',
     &         ' Faktor ',F5.2)
  440 FORMAT(/,' Alternating-Direction-Implicit - Zeile fuer Zeile')
  450 FORMAT(/,' Successive Over/Under-Relaxation - Zeile fuer Zeile -',
     &         ' Faktor ',F5.2)
  600 FORMAT(/,' Zusammenfassung der Eingangsparameter:',/,1H ,38(1H-))
  610 FORMAT(' Datei ',A20,' nicht gefunden - Bearbeitung abgebrochen')
      RETURN
      END
C&ISODRV
C **********************************************************************
C     Version 02011988  Subroutine ISODRV
C **********************************************************************
C
C *** Subroutine ISODRV koordiniert den Aufruf von ISODRV **************
C
      SUBROUTINE ISODRV
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /TEMP/T,T0,STMP
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /ISOP/IXISO,IYISO,IZISO,ISO1,IMSBIN
C
      IF (IECHO.GE.1) CALL ROUTIN ('ISODRV')
C
      IF (IMSBIN.EQ.1) GO TO 10
      IF (IGWF.LE.1) THEN
         IF (IXISO.EQ.1) CALL ISOASC (11,IY,IZ,NY,NZ,DIFY,DIFZ)
         IF (IYISO.EQ.1) CALL ISOASC (12,IX,IZ,NX,NZ,DIFX,DIFZ)
         IF (IZISO.EQ.1) CALL ISOASC (13,IX,IY,NX,NY,DIFX,DIFY)
      END IF
      IF (IGWF.GE.1) THEN
         IF (IXISO.EQ.1) CALL ISOASC (21,IY,IZ,NY,NZ,DIFY,DIFZ)
         IF (IYISO.EQ.1) CALL ISOASC (22,IX,IZ,NX,NZ,DIFX,DIFZ)
         IF (IZISO.EQ.1) CALL ISOASC (23,IX,IY,NX,NY,DIFX,DIFY)
      END IF
      ISO1 = 1
      RETURN
10    IF (IGWF.LE.1) THEN
         IF (IXISO.EQ.1) CALL ISOBIN (11,IY,IZ,NY,NZ,DIFY,DIFZ)
         IF (IYISO.EQ.1) CALL ISOBIN (12,IX,IZ,NX,NZ,DIFX,DIFZ)
         IF (IZISO.EQ.1) CALL ISOBIN (13,IX,IY,NX,NY,DIFX,DIFY)
      END IF
      IF (IGWF.GE.1) THEN
         IF (IXISO.EQ.1) CALL ISOBIN (21,IY,IZ,NY,NZ,DIFY,DIFZ)
         IF (IYISO.EQ.1) CALL ISOBIN (22,IX,IZ,NX,NZ,DIFX,DIFZ)
         IF (IZISO.EQ.1) CALL ISOBIN (23,IX,IY,NX,NY,DIFX,DIFY)
      END IF
      ISO1 = 1
      RETURN
      END
C&ISOASC
C **********************************************************************
C     Version 02011988  Subroutine ISOASC
C **********************************************************************
C
C *** Subroutine ISOASC erzeugt Eingangsdaten fuer den Postprozessor ***
C
      SUBROUTINE ISOASC (ISOUN,II,JJ,NI,NJ,DIFI,DIFJ)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DIFI(II),DIFJ(JJ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /ISOP/IXISO,IYISO,IZISO,ISO1,IMSBIN
C
      IF (IECHO.GE.1) CALL ROUTIN ('ISOASC')
C
      IF (ISO1.EQ.0) THEN
        WRITE (ISOUN,100) NI,NJ
        WRITE (ISOUN,110) (DIFI(I),I = 1, NI-1)
        WRITE (ISOUN,110) (DIFJ(J),J = 1, NJ-1)
      END IF
      WRITE (ISOUN,120) SUMSEK
      IF (ISOUN.EQ.11) THEN
         DO 10 J = 1, NJ
         WRITE (ISOUN,110) (CELS(T(IPROX,I,J)),I = 1, NI)
   10    CONTINUE
      END IF
      IF (ISOUN.EQ.12)  THEN
         DO 20 J = 1, NJ
         WRITE (ISOUN,110) (CELS(T(I,IPROY,J)),I = 1, NI)
   20    CONTINUE
      END IF
      IF (ISOUN.EQ.13) THEN
         DO 30 J = 1, NJ
         WRITE (ISOUN,110) (CELS(T(I,J,IPROZ)),I = 1, NI)
   30    CONTINUE
      END IF
      IF (ISOUN.EQ.21) THEN
         DO 40 J = 1, NJ
         WRITE (ISOUN,110) (H(IPROX,I,J),I = 1, NI)
   40    CONTINUE
      END IF
      IF (ISOUN.EQ.22)  THEN
         DO 50 J = 1, NJ
         WRITE (ISOUN,110) (H(I,IPROY,J),I = 1, NI)
   50    CONTINUE
      END IF
      IF (ISOUN.EQ.23) THEN
         DO 60 J = 1, NJ
         WRITE (ISOUN,110) (H(I,J,IPROZ),I = 1, NI)
   60    CONTINUE
      END IF
  100 FORMAT(2I5)
  110 FORMAT(200F10.4)
  120 FORMAT(F12.2)
      RETURN
      END
C&ISOBIN
C **********************************************************************
C     Version 12091988  Subroutine ISOBIN 
C **********************************************************************
C
C *** Subroutine ISOBIN erzeugt Eingangsdaten fuer den Postprozessor ***
C
      SUBROUTINE ISOBIN (ISOUN,II,JJ,NI,NJ,DIFI,DIFJ)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DIFI(II),DIFJ(JJ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /ISOP/IXISO,IYISO,IZISO,ISO1,IMSBIN
C
      IF (IECHO.GE.1) CALL ROUTIN ('ISOBIN')
C
      IF (ISO1.EQ.0) THEN
        WRITE (ISOUN) 'BINARY'
        WRITE (ISOUN) NI,NJ
        WRITE (ISOUN) (DIFI(I),I = 1, NI-1)
        WRITE (ISOUN) (DIFJ(J),J = 1, NJ-1)
      END IF
      WRITE (ISOUN) SUMSEK
      IF (ISOUN.EQ.11) THEN
         DO 10 J = 1, NJ
         WRITE (ISOUN) (REAL(CELS(T(IPROX,I,J))),I = 1, NI)
   10    CONTINUE
      END IF
      IF (ISOUN.EQ.12)  THEN
         DO 20 J = 1, NJ
         WRITE (ISOUN) (REAL(CELS(T(I,IPROY,J))),I = 1, NI)
   20    CONTINUE
      END IF
      IF (ISOUN.EQ.13) THEN
         DO 30 J = 1, NJ
         WRITE (ISOUN) (REAL(CELS(T(I,J,IPROZ))),I = 1, NI)
   30    CONTINUE
      END IF
      IF (ISOUN.EQ.21) THEN
         DO 40 J = 1, NJ
         WRITE (ISOUN) (H(IPROX,I,J),I = 1, NI)
   40    CONTINUE
      END IF
      IF (ISOUN.EQ.22)  THEN
         DO 50 J = 1, NJ
         WRITE (ISOUN) (H(I,IPROY,J),I = 1, NI)
   50    CONTINUE
      END IF
      IF (ISOUN.EQ.23) THEN
         DO 60 J = 1, NJ
         WRITE (ISOUN) (H(I,J,IPROZ),I = 1, NI)
   60    CONTINUE
      END IF
      RETURN
      END
C&ITERAH
C **********************************************************************
C     Version 22031988  Subroutine ITERAH
C **********************************************************************
C
C *** Subroutine ITERAH iterative Loesung des Stroemungsfeldes *********
C
      SUBROUTINE ITERAH
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION FEHL
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INCB/INDX,INDY,INDZ,IADD,JADD,KADD
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /WPOT/H,H0
C
   90 IF (IECHO.GE.1) CALL ROUTIN ('ITERAH')
C
      OMEGA = OMGH
      LMAX = KD
      IF (NZ.EQ.1) LMAX = 4
      IF (NZ.EQ.1.AND.NY.EQ.1) LMAX = 2
      IAUSOP = 1
      NIT = 0
      M = 0
      IF (IECHO.GE.1) WRITE (1,*)
  100 NIT = NIT + 1
      FELALT = 0.
      M = M + 1
      CALL RICHTG (M,KANF,KEND,KPLUS,NZ,IALTER)
      DO 10 K = KANF, KEND, KPLUS
      IF (NZ.EQ.1) N = M
      CALL RICHTG (N,JANF,JEND,JPLUS,NY,IALTER)
      HU = HOENN - ZKOR(K) - DIVZ(K,2)
      HO = HU + DELTAZ(K)
      DO 10 J = JANF, JEND, JPLUS
      CALL RICHTG (J,IANF,IEND,IPLUS,NX,IALTER)
      DO 10 I = IANF, IEND, IPLUS
C
      GO TO (1000,10) JFLAG(I,J,K)
C
C *** IFLAG = 1  ==> variables Potential *******************************
C
 1000 AH = 0.
      DO 20 L = 1, LMAX
      II = I + INDX(L)
      JJ = J + INDY(L)
      KK = K + INDZ(L)
      IF (II.EQ.0.OR.II.EQ.NX+1) GO TO 20
      IF (JJ.EQ.0.OR.JJ.EQ.NY+1) GO TO 20
      IF (KK.EQ.0.OR.KK.EQ.NZ+1) GO TO 20
      CALL WICHHY (II,JJ,KK,HH)
      AH = AH + ANB(I,J,K,L) * HH
   20 CONTINUE
      HALT = H(I,J,K)
      H(I,J,K) = HALT + OMEGA * ((AH + B(I,J,K)) / AP1(I,J,K) - HALT)
      HNEU = H(I,J,K)
      IF (HALT.LT.HO.AND.HNEU.GT.HO) CALL DELTAH (I,J,K)
      IF (HNEU.LT.HO) CALL DELTAH (I,J,K)
      FELNEU = ABS(HALT - HNEU)
      IF (FELNEU.GT.FELALT) FELALT = FELNEU
   10 CONTINUE
      IF (IECHO.GE.1) WRITE (1,30) NIT,FELALT
      IF (FELALT.GT.FEHLH.AND.NIT.LT.ILOOP) GO TO 100
      FEHLER = FELALT
      FEHL = FELALT
      IF (ISOR.EQ.2) THEN
         ALFA = ALFAHY
         CALL OMEGAT(FEHL,OMEGA,ALFA)
         IF (ISOR.NE.1) THEN
            CALL KOEFFH
            GO TO 90
         END IF
      END IF
   30 FORMAT(1H+,' Iteration Nummer ==> ',I3,' === Iterationsfehler = ',
     &       F11.6)
      RETURN
      END
C&ITERAT
C **********************************************************************
C     Version 08071987  Subroutine ITERAT
C **********************************************************************
C
C *** Subroutine ITERAT iterative Loesung des Temperaturfeldes *********
C
      SUBROUTINE ITERAT
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      DOUBLE PRECISION T,T0,TALT,TNEU,TT,STMP,FELALT,FELNEU,AT
      CHARACTER FLAG*4,UFLS*4
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INCB/INDX,INDY,INDZ,IADD,JADD,KADD
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /TEMP/T,T0,STMP
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
C
  100 IF (IECHO.GE.1) CALL ROUTIN ('ITERAT')
C
      OMEGA = OMGT
      LMAX = KD
      IF (NZ.EQ.1) LMAX = 4
      IF (NZ.EQ.1.AND.NY.EQ.1) LMAX = 2
      IAUSOP = 1
      NIT = 0
      M = 0
      IF (IECHO.GE.1) WRITE (1,*)
 5000 NIT = NIT + 1
      FELALT = 0.
      M = M + 1
      CALL RICHTG (M,KANF,KEND,KPLUS,NZ,IALTER)
      DO 10 K = KANF, KEND, KPLUS
      IF (NZ.EQ.1) N = M
      CALL RICHTG (N,JANF,JEND,JPLUS,NY,IALTER)
      DO 10 J = JANF, JEND, JPLUS
      CALL RICHTG (J,IANF,IEND,IPLUS,NX,IALTER)
      DO 10 I = IANF, IEND, IPLUS
C
      GO TO (1000,10,10,10,10) IABS(IFLAG(I,J,K))
C
C *** IFLAG = 1  ==> variable Temperatur *******************************
C
 1000 AT = 0.
      DO 20 L = 1, LMAX
      II = I + INDX(L)
      JJ = J + INDY(L)
      KK = K + INDZ(L)
      IF (II.EQ.0.OR.II.EQ.NX+1) GO TO 20
      IF (JJ.EQ.0.OR.JJ.EQ.NY+1) GO TO 20
      IF (KK.EQ.0.OR.KK.EQ.NZ+1) GO TO 20
      CALL WICHTP (II,JJ,KK,TT)
      AT = AT + ANB(I,J,K,L) * TT
   20 CONTINUE
      TALT = T(I,J,K)
      T(I,J,K) = TALT + OMEGA * ((AT + B(I,J,K)) / AP1(I,J,K) - TALT)
      IF (IFROST.GE.1) CALL PHATST (I,J,K,TALT,T(I,J,K))
      FELNEU = DABS(T(I,J,K) - TALT)
      IF (FELNEU.GT.FELALT) FELALT = FELNEU
   10 CONTINUE
      IF (IWCP.GE.3) CALL KOEFFT (1,1,1,NX,NY,NZ)
      IF (IECHO.GE.1) WRITE (1,30) NIT,FELALT
      IF (FELALT.GT.FEHLT.AND.NIT.LT.ILOOP) GO TO 5000
      FEHLER = FELALT
      IF (ISOR.EQ.1) THEN
         ALFA = ALFATP
         CALL OMEGAT(FELALT,OMEGA,ALFA)
         IF (ISOR.NE.0) GO TO 100
      END IF
   30 FORMAT(1H+,' Iteration Nummer ==> ',I3,' === Iterationsfehler = ',
     &       F11.6)
      RETURN
      END
C&KOEFFH
C **********************************************************************
C     Version 22031988  Subroutine KOEFFH
C **********************************************************************
C
C *** Subroutine KOEFFH Berechnung der Nachbarkoeffizienten fuer H *****
C
      SUBROUTINE KOEFFH
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
C
      IF (IECHO.GE.1) CALL ROUTIN ('KOEFFH')
C
      IF (IGWF.LE.1) CALL FLUSFL(1,1,1,NX,NY,NZ)
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      DO 10 I = 1, NX
      CALL KONDUK (I,J,K)
   10 CONTINUE
      IF (IECHO.GE.2) WRITE (1,*)
      DO 20 K = 1, NZ
      IF (IECHO.EQ.1) WRITE (1,100) K
      DO 20 J = 1, NY
      DO 20 I = 1, NX
      CALL KONKOF (I,J,K)
      DO 20 L = 1, KD
      ANB(I,J,K,L) = DNB(L)
   20 CONTINUE
  100 FORMAT(1H+,T17,'***** Schicht ',I4,' wird berechnet ****')
      RETURN
      END
C&KOEFFT
C **********************************************************************
C     Version 30061987  Subroutine KOEFFT
C **********************************************************************
C
C *** Subroutine KOEFFT Berechnung der Nachbarkoeffizienten fuer T *****
C
      SUBROUTINE KOEFFT (I1,J1,K1,I2,J2,K2)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      COMMON /ENER/SC,SP,FRO
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
C
      IF (IECHO.GE.1) CALL ROUTIN ('KOEFFT')
C
      LMAX = KD2
      IF (NZ.EQ.1) LMAX = 2
      IF (NZ.EQ.1.AND.NY.EQ.1) LMAX = 1
      LM2 = LMAX * 2
      DO 80 K = K1, K2
      DO 80 J = J1, J2
      DO 80 I = I1, I2
         CALL KONINF (I,J,K)
   80 CONTINUE
      IF (IDIF.EQ.1) THEN
C *** Diffusion und Konvektion *****************************************
         IF (IGWF.EQ.0) CALL FLUSFL (I1,J1,K1,I2,J2,K2)
         IF (IECHO.GE.2) WRITE (1,*)
         DO 10 K = K1, K2
         IF (IECHO.GE.2) WRITE (1,100) K
         DO 10 J = J1, J2
         DO 10 I = I1, I2
            CALL KONKOF (I,J,K)
            CALL FLUKOF (I,J,K)
            CALL PECLET (LM2)
            LL = 0
            DO 10 L = 1, LMAX
               LL = LL + 1
               ANB(I,J,K,LL) = DNB(LL) * PECL(LL) + AMAX1( FNB(LL), 0.)
               LL = LL + 1
               ANB(I,J,K,LL) = DNB(LL) * PECL(LL) + AMAX1(-FNB(LL), 0.)
   10    CONTINUE
      ELSE
C *** nur Diffusion ****************************************************
         IF (IECHO.GE.2) WRITE (1,*)
         DO 70 K = K1, K2
         IF (IECHO.GE.2) WRITE (1,100) K
         DO 70 J = J1, J2
         DO 70 I = I1, I2
            CALL KONKOF (I,J,K)
            DO 70 L = 1, LM2
               ANB(I,J,K,L) = DNB(L)
   70    CONTINUE
      END IF
C
      DO 20 K = K1, K2
      STP = CELS(STMP(K))
      DO 20 J = J1, J2
      DO 20 I = I1, I2
C
C *** konstante Temperatur *********************************************
C
         IF (IFLAG(I,J,K).EQ.2.OR.IFLAG(I,J,K).EQ.5) THEN
            AP0(I,J,K) = ZZZZ
         ELSE
            TMP = CELS(T(I,J,K))
            ROG = RHOG(I,J,K)
            POR = PHIG(I,J,K)
            SOL = 1. - PHIG(I,J,K)
            ROP = RHOH2O(TMP,STP,K) * SATU(K) + RHOL * (1. - SATU(K))
C
C *** nur Diffusion ****************************************************
C
            IF (IDIF.EQ.0) THEN
               IF (TMP.GE.STP) THEN
                  CPP  = CPW * SATU(K) + CPL * (1. - SATU(K))
               ELSE
                  CALL WCPH2O (CPF,TMP-STP,K)         
                  CPP  = CPF * SATU(K) + CPL * (1. - SATU(K))
               END IF         
               ROPHI = CPP * ROP * POR + CPG(I,J,K) * ROG * SOL
               AP0(I,J,K) = DXYZ(I,J,K) * ROPHI / DZEIT
            ELSE  
C
C *** Diffusion und Konvektion *****************************************
C
               ROPHI = ROP * POR + ROG * SOL
               AP0(I,J,K) = DXYZ(I,J,K) * ROPHI / DZEIT
            END IF
         END IF   
   20 CONTINUE
C
C *** Addieren aller Nachbarkoeffizienten ******************************
C
      DO 40 K = K1, K2
      DO 40 J = J1, J2
      DO 40 I = I1, I2
         AP = 0.
         DO 30 L = 1, LM2
            AP = AP + ANB(I,J,K,L)
   30    CONTINUE
         AP1(I,J,K) = AP + AP0(I,J,K)
   40 CONTINUE
      RETURN
  100 FORMAT(1H+,T17,'***** Schicht ',I4,' wird berechnet ****')
      END
C&KONDUK
C **********************************************************************
C     Version 21031988  Subroutine KONDUK
C **********************************************************************
C
C *** Subroutine KONDUK berechnet die Interfacekonduktivitaet **********
C
      SUBROUTINE KONDUK (I,J,K)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /INF5/IVIS,IWRO
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /WPOT/H,H0
C
      TREST = 1E-5
C
C *** Restpermeabilitaet, falls die Zellen leerlaufen ... **************
C
      HU = HOENN - ZKOR(K) - DIVZ(K,2)
      HO = HU + DELTAZ(K)
C
C *** Berechnung der benetzten, vertikalen Zellengrenzhoehe ************
C
      TKX1 = TTX(I,J,K)
      TKY1 = TTY(I,J,K)
      TKZ1 = TTZ(I,J,K)
      IF (K.LT.NZ) THEN
         TKZ2 = TTZ(I,J,K+1)
         IF (IFLUS(I,J,K+1).EQ.0.AND.IGWF.LE.1) TKZ2 = 0.
      END IF
      IF (IFLUS(I,J,K).EQ.0.AND.IGWF.LE.1) THEN
         TKX1 = 0.
         TKY1 = 0.
         TKZ1 = 0.
      END IF
      IF (I.EQ.NX) THEN
          TRX = 0.
          GO TO 10
      END IF
      TKX2 = TTX(I+1,J,K)
      CALL HARMON (TKX1,TKX2,TKX,FX(I))
      IF (H(I,J,K).LT.HO.OR.H(I+1,J,K).LT.HO) THEN
C
C *** gewichtetes, geometrisches Mittel ... ****************************
C
         IF (H(I,J,K).GT.HU) THEN
            DHX = (H(I,J,K) - HU) ** (1. - FX(I)) *
     &            MIN(ABS(H(I+1,J,K) - HU), DELTAZ(K)) ** FX(I)
            TRX = TKX * DHX / DELTAZ(K)
         ELSE
            TRX = TREST
         END IF
      ELSE
         TRX = TKX
      END IF
   10 IF (J.EQ.NY) THEN
         TRY = 0.
         GO TO 20
      END IF
      TKY2 = TTY(I,J+1,K)
      CALL HARMON (TKY1,TKY2,TKY,FY(J))
      IF (H(I,J,K).LT.HO.OR.H(I,J+1,K).LT.HO) THEN
C
C *** gewichtetes, geometrisches Mittel ... ****************************
C
         IF (H(I,J,K).GT.HU) THEN
            DHY = (H(I,J,K) - HU) ** (1. - FY(J)) *
     &            MIN(ABS(H(I,J+1,K) - HU), DELTAZ(K)) ** FY(J)
            TRY = TKY * DHY / DELTAZ(K)
         ELSE
            TRY = TREST
         END IF
      ELSE
         TRY = TKY
      END IF
   20 CALL HARMON (TKZ1,TKZ2,TRZ,FZ(K))
      VISX = 1.
      VISY = 1.
      VISZ = 1.
      IF (IVIS.EQ.1) CALL VISKOS (I,J,K,VISX,VISY,VISZ)
      WTI(I,J,K,1) = TRX/VISX
      WTI(I,J,K,2) = TRY/VISY
      WTI(I,J,K,3) = TRZ/VISZ
      RETURN
      END
C&KONINF
C **********************************************************************
C     Version 13061987  Subroutine KONINF
C **********************************************************************
C
C *** Subroutine KONINF Berechnung der Interface-Diffusion *************
C
      SUBROUTINE KONINF (I,J,K)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION WLK(4), CC(4)
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /INCB/INDX,INDY,INDZ,IADD,JADD,KADD
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PAR4/DTW,DTW2,DWAN,DTWL(3)
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TEMP/T,T0,STMP
      BRUCH = 0.
      DO 20 L = 1, 4
         II = I + IADD(L)
         JJ = J + JADD(L)
         KK = K + KADD(L)
         IF (II.GT.NX.OR.JJ.GT.NY.OR.KK.GT.NZ) THEN
            WLK(L) = 0.
            GO TO 20
         END IF
         TDIF = T(II,JJ,KK) - STMP(KK)
         SAT = SATU(KK)
         IF (TDIF.GT.0.) THEN
            IF (IDIF.EQ.1) CPP = CPW * SAT + CPL * (1. - SAT)
            RK1 = WLW * SAT + WLL * (1. - SAT)
         ELSE
            CALL WASEIS (WE,TDIF,KK)         
            IF (IDIF.EQ.1) THEN 
               CALL WCPH2O (CPF,TDIF,KK)         
               CPP = CPF * SAT + CPL * (1. - SAT)
            END IF   
            RK1 = (WE * WLW + (1.- WE) * WLE) * SAT + WLL * (1. - SAT)
         END IF
C
C *** falls die WLF temperaturabhaengig ist ... ************************
C
         IF (IWCP.GE.3) THEN
            RK = WLKG(II,JJ,KK)
            TT = CELS(T(II,JJ,KK))
C
C *** polynomisches Modell *********************************************
C
            IF (IWCP.EQ.3)  RK2 = RK + TT * RK * (DTWL(1) + TT *
     &                            (DTWL(2) + TT * DTWL(3)))
C
C *** exponentielles Modell ********************************************
C
            IF (IWCP.EQ.4)  RK2 = RK * DTWL(1) * EXP(DTWL(2) * TT) +
     &                            DTWL(3) * RK
C
C *** BUNTEBARTH & RUEFF (1988) ****************************************
C
            IF (IWCP.EQ.5)  RK2 = RK / (1. + RK * DTWL(1) *
     &                            (TT - 20.)) + 0.027 * DTWL(2) * 
     &                            (ZKOR(K) - 400.)      
                
         ELSE
            RK2 = WLKG(II,JJ,KK)
         END IF   
         PHI = PHIG(II,JJ,KK)
         IF (MODEL.EQ.1 .OR. MODEL.EQ.2) THEN
            IF (RK2.EQ.0.) RK2 = 1. / ZZZZ
            RK12 = RK1 / RK2
            RK12M1 = 1. - RK12
         END IF   
C
C     Berechnung der effektiven Waermeleitfaehigkeit bei von unter-
C     schiedlichen Porenraumverteilungen nach WALSH & DECKER (1966)
C
C     MODEL = 1   ==>  Maximaleinfluss des Porenraumes
C     MODEL = 2   ==>  Minimaleinfluss des Porenraumes
C     MODEL = 3   ==>  arithmetrisches Mittel
C     
         IF (MODEL.EQ.1) THEN
            BRUCH = (PHI * (1. + 2. * RK12) * RK12M1) /
     &              (PHI * RK12M1 + 3. * RK12)
            RM1MB  = RK2 * (1. - BRUCH)
         END IF
C
         IF (MODEL.EQ.2) THEN
            BRUCH = (3. * PHI * RK12M1) / (2. + PHI + RK12)
            RM1MB  = RK2 * (1. - BRUCH)
         END IF
         IF (RM1MB.LT.1E-20) RM1MB = 0.
C
         IF (MODEL.NE.1.AND.MODEL.NE.2) 
     &       RM1MB  = PHI * RK1 + (1. - PHI) * RK2
C
         WLK(L) = RM1MB
         IF (IDIF.EQ.1) CC(L) = (1. - PHI) * CPG(II,JJ,KK) + PHI *  CPP
   20 CONTINUE
C
C *** Interface-Leitfaehigkeit - gewichtetes, harmonisches Mittel ******
C
      IF (I.LT.NX) THEN
        CALL HARMON (WLK(1)*ANISO(1),WLK(2)*ANISO(1),WTI(I,J,K,1),FX(I))
        IF (IDIF.EQ.1) THEN
           CALL HARMON (CC(1),CC(2),CCI,FX(I))
           IF (CCI.EQ.0.) CCI = 1.
           WTI(I,J,K,1) = WTI(I,J,K,1) / CCI
        END IF
      END IF     
      IF (J.LT.NY) THEN
        CALL HARMON (WLK(1)*ANISO(2),WLK(3)*ANISO(2),WTI(I,J,K,2),FY(J))
        IF (IDIF.EQ.1) THEN
           CALL HARMON (CC(1),CC(3),CCI,FY(J))
           IF (CCI.EQ.0.) CCI = 1.
           WTI(I,J,K,2) = WTI(I,J,K,2) / CCI
        END IF
      END IF     
      IF (K.LT.NZ) THEN
        CALL HARMON (WLK(1)*ANISO(3),WLK(4)*ANISO(3),WTI(I,J,K,3),FZ(K))
        IF (IDIF.EQ.1) THEN
           CALL HARMON (CC(1),CC(4),CCI,FZ(K))
           IF (CCI.EQ.0.) CCI = 1.
           WTI(I,J,K,3) = WTI(I,J,K,3) / CCI
        END IF
      END IF     
      RETURN
      END
C&KONKOF
C **********************************************************************
C     Version 20061987  Subroutine KONKOF
C **********************************************************************
C
C *** Subroutine KONKOF Berechnung der Konduktionskoeffizienten ********
C
      SUBROUTINE KONKOF (I,J,K)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      DO 10 L = 1, KD
         DNB(L) = 0.
   10 CONTINUE
      IF (I.GT.1)
     &   DNB(1) = WTI(I-1,J,K,1) * DELTAY(J) * DELTAZ(K) / DIFX(I-1)
      IF (I.LT.NX)
     &   DNB(2) = WTI(I,J,K,1)   * DELTAY(J) * DELTAZ(K) / DIFX(I)
      IF (J.GT.1)
     &   DNB(3) = WTI(I,J-1,K,2) * DELTAX(I) * DELTAZ(K) / DIFY(J-1)
      IF (J.LT.NY) 
     &   DNB(4) = WTI(I,J,K,2)   * DELTAX(I) * DELTAZ(K) / DIFY(J)
      IF (K.GT.1)  
     &   DNB(5) = WTI(I,J,K-1,3) * DELTAX(I) * DELTAY(J) / DIFZ(K-1)
      IF (K.LT.NZ)
     &   DNB(6) = WTI(I,J,K,3)   * DELTAX(I) * DELTAY(J) / DIFZ(K)
      RETURN
      END
C&KOPIER
C **********************************************************************
C     Version 26061987  Subroutine KOPIER
C **********************************************************************
C
C *** Subroutine KOPIER Kopieren der T oder H-Werte in ein anderes Feld
C
      SUBROUTINE KOPIER (IKOP)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      COMMON /WPOT/H,H0
      COMMON /TEMP/T,T0,STMP
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
C
      IF (IECHO.GE.1) CALL ROUTIN ('KOPIER')
C
      IF (IKOP.EQ.1) THEN
         DO 10 K = 1, NZ
         DO 10 J = 1, NY
         DO 10 I = 1, NX
            T0(I,J,K) = T(I,J,K)
   10    CONTINUE
      ELSE
         DO 20 K = 1, NZ
         DO 20 J = 1, NY
         DO 20 I = 1, NX
            H0(I,J,K) = H(I,J,K)
   20    CONTINUE
      END IF   
      RETURN
      END
C&KURZIN
C **********************************************************************
C     Version 09081987  Subroutine KURZIN
C **********************************************************************
C
C *** Subroutine KURZIN Einlesen der Daten - kurzer Input **************
C
      SUBROUTINE KURZIN
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      DOUBLE PRECISION T,T0,STMP,CELV,TT
      CHARACTER FORMIN*20,FLAG*4,UFLS*4,CARD*3
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /ENER/SC,SP,FRO
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
      PI = ATAN(1.) * 4.
C
      IF (IECHO.GE.1) CALL ROUTIN ('KURZIN')
C
C *** optionale Eingabe der Randbedingungen und Anisotropiefaktoren ****
C
      CARD = '19'
      READ (5,100,END=200) FORMIN
      READ (5,FORMIN,ERR=300,END=200) IBX,IBY,IBZ,ANISO(1),
     &                                ANISO(2),ANISO(3)
C
C *** Subroutine GITTER Berechnung der Gitterparameter *****************
C
      CALL GITTER
      READ (5,100,ERR=300,END=200) FORMIN
      DO 10 K = 1, NZ
C
C *** Karte 27a *** Temperaturberechnung mit vorgegebener Stroemung ****
C
      IF (IGWF.EQ.0) THEN
         CARD = '27a'
         READ (5,FORMIN,ERR=300,END=200) TT,CCPG,RRHOG,WWLKG,
     &                                   PPHIG,PPHIN,SSATU,SSC,
     &                                   WINKEL,GWV,VVZ,IIFLAG
C
C *** Fliessgeschwindigkeit in m/sec und Richtung **********************
C
         VVX = 0.
         VVY = 0.
         IF (SSATU.GE.100.) THEN
            VVX = SIN((WINKEL) * (PI / 180.)) * GWV
            VVY = COS((WINKEL + 180.) * (PI / 180.)) * GWV
            VVZ = 0.
         END IF
         TT      = CELV(TT)
         RRHOG   = RRHOG * 1000.
         PPHIG   = PPHIG / 100.
         PPHIN   = PPHIN / 100.
         SATU(K) = SSATU / 100.
      END IF
C
C *** Karte 27b *** Temperatur- und Stroemungsberechnung gekoppelt *****
C
      IF (IGWF.EQ.1) THEN
         CARD = '27b'
         READ (5,FORMIN,ERR=300,END=200) TT,CCPG,RRHOG,WWLKG,
     &                                   PPHIG,PPHIN,SSC,QQ,SSK,HH,
     &                                   TTTX,TTTY,TTTZ,
     &                                   SSATU,IIFLAG,JJFLAG
         TT      =  CELV(TT)
         RRHOG   =  RRHOG * 1000.
         PPHIG   =  PPHIG / 100.
         PPHIN   =  PPHIN / 100.
         SATU(K) =  SSATU / 100.
      END IF
C
C *** Karte 27c *** nur Stroemungsberechnung ***************************
C
      IF (IGWF.EQ.2) THEN
         CARD = '27c'
         READ (5,FORMIN,ERR=300,END=200) HH,TTTX,TTTY,TTTZ,QQ,SSK,PPHIN,
     &                                   JJFLAG
         PPHIN = PPHIN / 100.
      END IF
C
C *** Vorbesetzung der Felder ******************************************
C
      DO 10 J = 1, NY
      DO 10 I = 1, NX
         IF (IGWF.EQ.0) THEN
            VX(I,J,K)    =  VVX
            VY(I,J,K)    =  VVY
            VZ(I,J,K)    =  VVZ
            PHIN(I,J,K)  =  PPHIN
         END IF
         IF (IGWF.LE.1) THEN
            T(I,J,K)     =  TT
            CPG(I,J,K)   =  CCPG
            RHOG(I,J,K)  =  RRHOG
            WLKG(I,J,K)  =  WWLKG
            SC(I,J,K)    =  SSC
            PHIG(I,J,K)  =  PPHIG
            IFLAG(I,J,K) =  IIFLAG
         END IF
         IF (IGWF.GE.1) THEN
            H(I,J,K)     =  HH
            TTX(I,J,K)   =  TTTX
            TTY(I,J,K)   =  TTTY
            TTZ(I,J,K)   =  TTTZ
            Q(I,J,K)     =  QQ
            SK(I,J,K)    =  SSK
            PHIN(I,J,K)  =  PPHIN
            JFLAG(I,J,K) =  JJFLAG
         END IF
   10 CONTINUE
      READ (5,100,END=200) FORMIN
      LUMW = 0
      CARD = '29'
      DO 20 L = 1, IWERT
         READ (5,FORMIN,ERR=300,END=400) FLAG(L),WERT(L),IXX(L),IYY(L),
     &                                   IZZ(L),IUFL(L)
         IF (FLAG(L).EQ.'ENDE') GO TO 120
         LUMW = LUMW + 1
   20 CONTINUE
      WRITE (1,110)
      STOP
C *** Besetzung des IFLAG - Feldes, falls IBX,IBY,IBZ = 1 *************
  120 CLOSE(5)
      CALL CHECKU(1)
      IF (IBZ.GT.0) THEN
         DO 50 K = 1, NZ, NZ1
         DO 50 J = 1, NY
         DO 50 I = 1, NX
            IF ((IBZ.EQ.1.OR.IBZ.EQ.3).AND.IGWF.LT.2) IFLAG(I,J,K) = 2
            IF ((IBZ.EQ.2.OR.IBZ.EQ.3).AND.IGWF.GE.1) JFLAG(I,J,K) = 2
   50    CONTINUE
      END IF
      IF (IBY.GT.0) THEN
         DO 60 J = 1, NY, NY1
         DO 60 K = 1, NZ
         DO 60 I = 1, NX
            IF ((IBY.EQ.1.OR.IBY.EQ.3).AND.IGWF.LT.2) IFLAG(I,J,K) = 2
            IF ((IBY.EQ.2.OR.IBY.EQ.3).AND.IGWF.GE.1) JFLAG(I,J,K) = 2
   60    CONTINUE
      END IF
      IF (IBX.GT.0) THEN
         DO 70 I = 1, NX, NX1
         DO 70 K = 1, NZ
         DO 70 J = 1, NY
            IF ((IBX.EQ.1.OR.IBX.EQ.3).AND.IGWF.LT.2) IFLAG(I,J,K) = 2
            IF ((IBX.EQ.2.OR.IBX.EQ.3).AND.IGWF.GE.1) JFLAG(I,J,K) = 2
   70    CONTINUE
      END IF
      RETURN
  200 WRITE (1,210) CARD
      STOP
  300 WRITE (1,310) CARD
      STOP
  400 WRITE (1,410) CARD
      STOP
  100 FORMAT(A20)
  110 FORMAT(' Felddimension IWERT muss groesser gewaehlt werden')
  210 FORMAT(' unerwartet Ende der Eingabedatei erreicht in Karte ',A3)
  310 FORMAT(' fehlerhafte Datenstruktur in Karte ',A3)
  410 FORMAT(' fehlende ENDE - Anweisung in Karte ',A3)
      END
C&OBSDAT
C **********************************************************************
C     Version 24011988  Subroutine OBSDAT
C **********************************************************************
C
C *** Subroutine OBSDAT Knotentemperaturen auf File OBSFIL schreiben ***
C
      SUBROUTINE OBSDAT
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
C
      IF (IECHO.GE.1) CALL ROUTIN ('OBSDAT')
C
      ZEIT = SUMSEK / DZMF
      IF (IGWF.EQ.0) 
     &   WRITE (7,100) ZEIT,(CELS(T(IXOBS(I),IYOBS(I),IZOBS(I))),
     &                 I = 1, IOBS)
      IF (IGWF.EQ.1)
     &   WRITE (7,200) ZEIT,(CELS(T(IXOBS(I),IYOBS(I),IZOBS(I))),
     &               H(IXOBS(I),IYOBS(I),IZOBS(I)),I = 1, IOBS)
      IF (IGWF.EQ.2)
     &   WRITE (7,200) ZEIT,(H(IXOBS(I),IYOBS(I),IZOBS(I)),I = 1, IOBS)
  100 FORMAT(F12.3,10F8.3)
  200 FORMAT(F12.3,10F8.3,/,9X,10F8.3)
      RETURN
      END
C&OMEGAT
C **********************************************************************
C     Version 05111987  Subroutine OMEGAT
C **********************************************************************
C
C *** Subroutine OMEGAT Testen des OMEGA - Wertes bei SOR/SUR **********
C
      SUBROUTINE OMEGAT (FEHL,OMEGA,ALFA)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      CHARACTER ANTW*1, TEXT*10
      DOUBLE PRECISION T,T0,STMP,FEHL
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION TEXT(2)
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      TEXT(1) = 'Temperatur'
      TEXT(2) = 'Stroemungs'
C
      IF (IECHO.GE.1) CALL ROUTIN ('OMEGAT')
C
      WRITE (1,100) OMEGA,NIT,FEHL,ALFA
   30 WRITE (1,150)
      READ (*,160) ANTW
      IF (ANTW.EQ.'n'.OR.ANTW.EQ.'N') GO TO 20
      IF (ANTW.NE.'j'.AND.ANTW.NE.'J') GO TO 30
   40 WRITE (1,110)
      READ (*,*,ERR=40) OMEGA
   50 WRITE (1,130)
      READ (*,*,ERR=50) ALFA
      IF (ISOR.EQ.1) THEN
         DO 10 K = 1, NZ
         DO 10 J = 1, NY
         DO 10 I = 1, NX
            T(I,J,K) = T0(I,J,K)
   10    CONTINUE
         OMGT = OMEGA
         ALFATP = ALFA
      END IF
      IF (ISOR.EQ.2) THEN
         DO 15 K = 1, NZ
         DO 15 J = 1, NY
         DO 15 I = 1, NX
            H(I,J,K) = H0(I,J,K)
   15    CONTINUE
         OMGH = OMEGA
         ALFAHY = ALFA
      END IF
      RETURN
   20 WRITE (IAUS,170) TEXT(ISOR)
      WRITE (IAUS,120) OMEGA
      WRITE (IAUS,140) ALFA
      ISOR = ISOR - 1
      RETURN
  100 FORMAT(' Bei OMEGA = ',F5.3,' ergab sich nach ',I2,
     &       ' Iterationen ein Fehler von ',F8.6,/,
     &       ' Wichtungsfaktor ALFA = ',F5.2)
  110 FORMAT(T16,' Bitte neuen Wert fuer OMEGA eingeben ==>  ',\)
  120 FORMAT(' OMEGA - Wert wurde auf ',F4.2,' geaendert')
  130 FORMAT(T16,' Bitte neuen Wert fuer ALFA eingeben  ==>  ',\)
  140 FORMAT(' Wichtungsfaktor ALFA wurde auf ',F4.2,' geaendert')
  150 FORMAT(' Werden neue Werte fuer OMEGA und ALFA gewuenscht?  (J/N)
     &  ==> ',\)
  160 FORMAT(A1)
  170 FORMAT(/,' Aenderung in der ',A10,'berechnung:',/,1H ,38(1H-),/)
      END
C&PECLET
C **********************************************************************
C     Version 29061987  Subroutine PECLET
C **********************************************************************
C
C *** Subroutine PECLET Berechnung der Peclet - Wichtungsfunktion ******
C
      SUBROUTINE PECLET (LMAX)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
C
      GO TO (100, 200, 300, 400, 500) IPECL
C
C *** Zentrale Differenzen *********************************************
C
  100 CONTINUE
      DO 10 L = 1, LMAX
         IF (DNB(L).EQ.0.) THEN
             PECL(L) = 1.
         ELSE
             PECL(L) = 1. - 0.5 * ABS(FNB(L) / DNB(L))
         END IF
   10 CONTINUE   
      RETURN
C
C *** Upwind - Schema    COURANT, ISAACSON & REES (1952) ***************
C
  200 CONTINUE
      DO 20 L = 1, LMAX
         PECL(L) = 1.
   20 CONTINUE
      RETURN
C
C *** Hybrid - Schema    SPALDING (1972) *******************************
C
  300 CONTINUE
      DO 30 L = 1, LMAX
         IF (DNB(L).EQ.0.) THEN
            PECL(L) = 1.
         ELSE
            PECL(L) = AMAX1(0., (1. - 0.5 * ABS(FNB(L) / DNB(L))))
         END IF
   30 CONTINUE
      RETURN
C
C *** Power law - Schema    PANTAKAR (1979) ****************************
C
  400 CONTINUE
      DO 40 L = 1, LMAX
         IF (DNB(L).EQ.0.) THEN
            PECL(L) = 1.
         ELSE
            PECL(L) = AMAX1(0., (1. - 0.1 * ABS(FNB(L) / DNB(L))) ** 5)
         END IF
   40 CONTINUE
      RETURN
C
C *** Exponential - Schema  ********************************************
C
  500 CONTINUE
      DO 50 L = 1, LMAX
         IF (DNB(L).EQ.0..OR.FNB(L).EQ.0.) THEN
            PECL(L) = 1.
         ELSE
            P = FNB(L) / DNB(L)
            PECL(L) = ABS(P) / (EXP(ABS(P)) - 1.)
         END IF
   50 CONTINUE
      RETURN
      END
C&PIEDRU
C **********************************************************************
C     Version 24011989  Subroutine PIEDRU
C **********************************************************************
C
C *** Subroutine PIEDRU Drucken der berechneten Piezometerhoehen *******
C
      SUBROUTINE PIEDRU
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /WPOT/H,H0
C
      IF (IECHO.GE.1) CALL ROUTIN ('PIEDRU')
C
      CALL ZEITBE (IAUS)
      WRITE (IAUS,120) NIT
      IF (IPROY.EQ.0.OR.IPROY.GT.NY) GO TO 45
C *** X - Z  Schnitt ***************************************************
      WRITE (IAUS,20) YKOR(IPROY),IPROY
      WRITE (IAUS,30) (XKOR(I),I = 1, NX)
      DO 40 K = 1, NZ
      WRITE (IAUS,50) ZKOR(K),(H(I,IPROY,K), I = 1, NX)
   40 CONTINUE
   45 IF (IPROX.EQ.0.OR.IPROX.GT.NX) GO TO 85
C *** Y - Z  Schnitt ***************************************************
      WRITE (IAUS,60) XKOR(IPROX),IPROX
      WRITE (IAUS,70) (YKOR(J),J = 1, NY)
      DO 80 K = 1, NZ
      WRITE (IAUS,50) ZKOR(K),(H(IPROX,J,K), J = 1, NY)
   80 CONTINUE
   85 IF (IPROZ.EQ.0.OR.IPROZ.GT.NZ) GO TO 115
C *** X - Y Schnitt ****************************************************
      WRITE (IAUS,90) ZKOR(IPROZ),IPROZ
      WRITE (IAUS,100) (XKOR(I),I = 1, NX)
      DO 110 J = 1, NY
      WRITE (IAUS,50) YKOR(J),(H(I,J,IPROZ), I = 1, NX)
  110 CONTINUE
   20 FORMAT(/,T20,'X - Z Piezometerhoehen Y bei ',F7.2,
     &       ' Meter - Spalte ',I4,/)
   30 FORMAT('  Z\X     ',10F7.2,/,50(10X,10F7.2,/))
   50 FORMAT(F10.2,10F7.2,/,50(10X,10F7.2,/))
   60 FORMAT(/,T20,'Y - Z Piezometerhoehen X bei ',F7.2,
     &       ' Meter - Reihe ',I4,/)
   70 FORMAT('  Z\Y     ',10F7.2,/,50(10X,10F7.2,/))
   90 FORMAT(/,T20,'X - Y Piezometerhoehen Z bei ',F7.2,
     &       ' Meter - Schicht ',I4,/)
  100 FORMAT('  Y\X     ',10F7.2,/,50(10X,10F7.2,/))
  120 FORMAT(/,' Konvergenz seit dem letzten Zeitschritt nach ',I2,
     &       ' Iterationen')
  115 RETURN
      END
C&PHATST
C **********************************************************************
C     Version 11111987  Subroutine PHATST
C **********************************************************************
C
C *** Subroutine PHATST ueberprueft den Phasenwechsel ******************
C
      SUBROUTINE PHATST (I,J,K,TALT,TNEU)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,TALT,TNEU,STP,TDIF,cels
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PAR4/DTW,DTW2,DWAN,DTWL(3)
      COMMON /TEMP/T,T0,STMP
C
      IF (IECHO.GE.2) CALL ROUTIN ('PHATST')
C
      IF (IFLAG(I,J,K).NE.1) RETURN
      IF (TALT.GE.STMP(K).AND.TNEU.GE.STMP(K)) RETURN
      TDIF = TNEU - TALT
      IF (TDIF) 10, 20, 30
C 
C *** es wird kaelter ... **********************************************
C
   10 IF (TALT.GE.STMP(K)) THEN
         DT1 = - DTW2
         CALL WASEIS (WE1,DT1,K)
         DWE = 1. - WE1
         IF (DWE.GT.DWAN) THEN
            DDT = DTW * DWAN / DWE
         ELSE
            DDT = DTW
         END IF   
         T(I,J,K) = STMP(K) - DDT
      ELSE 
         DT1 = TALT - STMP(K) + DTW2
         IF (DT1.GT.0) DT1 = 0.
         CALL WASEIS (WE1,DT1,K)
         DT2 = TALT - STMP(K) - DTW2
         CALL WASEIS (WE2,DT2,K)
         DWE = WE1 - WE2
         IF (DWE.GT.DWAN) THEN
            DDT = (DT1 - DT2) * DWAN / DWE
         ELSE
            DDT = DT1 - DT2
         END IF    
         T(I,J,K) = TALT - DDT
      END IF
      GO TO 100
C 
C *** es hat sich nichts geaendert ... *********************************
C
   20 RETURN
C 
C *** es wird waermer ... **********************************************
C
   30 DT1 = TALT - STMP(K) - DTW2
      CALL WASEIS (WE1,DT1,K)
      DT2 = DT1 + DTW
      IF (DT2.GT.0.) DT2 = 0.
      CALL WASEIS (WE2,DT2,K)
      DWE = WE2 - WE1
      IF (DWE.GT.DWAN) THEN
         DDT = (DT2 - DT1) * DWAN / DWE
      ELSE
         DDT = DT2 - DT1
      END IF
      T(I,J,K) = TALT + DDT
  100 I1 = MAX0 ( 1, I-1)
      J1 = MAX0 ( 1, J-1)
      K1 = MAX0 ( 1, K-1)
      I2 = MIN0 (NX, I+1)
      J2 = MIN0 (NY, J+1)
      K2 = MIN0 (NZ, K+1)
      CALL KOEFFT (I1,J1,K1,I2,J2,K2)
      RETURN
      END
C&PROFIL
C **********************************************************************
C     Version 24061987  Subroutine PROFIL
C **********************************************************************
C
C *** Subroutine PROFIL Drucken der Eingangsdaten in Profilschnitten ***
C
      SUBROUTINE PROFIL (PROF,IPROF,NPROF)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      CHARACTER FORMOU*30,FORTXT*48
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION PROF(IX,IY,IZ),IPROF(IX,IY,IZ)
      DIMENSION FORMOU(8),FORTXT(8)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /FORM/FORMOU,FORTXT
C
      IF (IECHO.GE.1) CALL ROUTIN ('PROFIL')
C
      WRITE (IAUS,FORTXT(NPROF))
      IF (IPROY.LE.0.OR.IPROY.GT.NY) GO TO 35
C *** X - Z  Schnitt ***************************************************
      WRITE (IAUS,10) YKOR(IPROY),IPROY
      WRITE (IAUS,20) (XKOR(I),I = 1, NX)
      DO 30 K = 1, NZ
      IF (NPROF.EQ.3)
     &   WRITE (IAUS,FORMOU(NPROF)) ZKOR(K),(GRCBCM(PROF(I,IPROY,K)),
     &   I = 1, NX)
      IF (NPROF.LE.6.AND.NPROF.NE.3)
     &   WRITE (IAUS,FORMOU(NPROF)) ZKOR(K),(PROF(I,IPROY,K),I = 1, NX)
      IF (NPROF.GE.7)
     &   WRITE (IAUS,FORMOU(NPROF)) ZKOR(K),(IPROF(I,IPROY,K),I = 1, NX)
   30 CONTINUE
   35 IF (IPROX.LE.0.OR.IPROX.GT.NX) GO TO 65
C *** Y - Z  Schnitt ***************************************************
      WRITE (IAUS,40) XKOR(IPROX),IPROX
      WRITE (IAUS,50) (YKOR(J),J = 1, NY)
      DO 60 K = 1, NZ
      IF (NPROF.EQ.3)
     &   WRITE (IAUS,FORMOU(NPROF)) ZKOR(K),(GRCBCM(PROF(IPROX,J,K)),
     &   J = 1, NY)
      IF (NPROF.LE.6.AND.NPROF.NE.3)
     &   WRITE (IAUS,FORMOU(NPROF)) ZKOR(K),(PROF(IPROX,J,K),J = 1, NY)
      IF (NPROF.GE.7)
     &   WRITE (IAUS,FORMOU(NPROF)) ZKOR(K),(IPROF(IPROX,J,K),J = 1, NY)
   60 CONTINUE
   65 IF (IPROZ.LE.0.OR.IPROZ.GT.NZ) GO TO 95
C *** X - Y Schnitt ****************************************************
      WRITE (IAUS,70) ZKOR(IPROZ),IPROZ
      WRITE (IAUS,80) (XKOR(I),I = 1, NX)
      DO 90 J = 1, NY
      IF (NPROF.EQ.3)
     &   WRITE (IAUS,FORMOU(NPROF)) YKOR(J),(GRCBCM(PROF(I,J,IPROZ)),
     &   I = 1, NX)
      IF (NPROF.LE.6.AND.NPROF.NE.3)
     &   WRITE (IAUS,FORMOU(NPROF)) YKOR(J),(PROF(I,J,IPROZ),I = 1, NX)
      IF (NPROF.GE.7)
     &   WRITE (IAUS,FORMOU(NPROF)) YKOR(J),(IPROF(I,J,IPROZ),I = 1, NX)
   90 CONTINUE
   10 FORMAT(/,' X - Z - Schnitt Y bei ',F5.2,' Meter - Spalte ',I2)
   20 FORMAT('  Z\X  ',10F6.2,/,9(7X,10F6.2,/))
   40 FORMAT(/,' Y - Z - Schnitt X bei ',F5.2,' Meter - Reihe ',I2)
   50 FORMAT('  Z\Y  ',10F6.2,/,9(7X,10F6.2,/))
   70 FORMAT(/,' X - Y - Schnitt Z bei ',F5.2,' Meter - Schicht ',I2)
   80 FORMAT('  Y\X  ',10F6.2,/,9(7X,10F6.2,/))
   95 NPROF = NPROF + 1
      RETURN
      END
C&QKOEFH
C **********************************************************************
C     Version 13051988  Subroutine QKOEFH
C **********************************************************************
C
C *** Subroutine QKOEFH Berechnung des Quelltermkoeffizienten  Piez. ***
C
      SUBROUTINE QKOEFH
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /WPOT/H,H0
C
      IF (IECHO.GE.1) CALL ROUTIN ('QKOEFH')
C
C *** Addieren aller Nachbarkoeffizienten ******************************
C
      DO 10 K = 1, NZ
      HO = HOENN - ZKOR(K) - DIVZ(K,2) + DELTAZ(K)
      DO 10 J = 1, NY
      DO 10 I = 1, NX
      SPK = SK(I,J,K)
      IF (HO.GT.H(I,J,K)) SPK = PHIN(I,J,K)
      IF (JFLAG(I,J,K).EQ.2) SPK = ZZZZ
      AP0(I,J,K) = DELTAX(I) * DELTAY(J) * SPK / DZEIT
      AP = 0.
      DO 20 L = 1, KD
      AP = AP + ANB(I,J,K,L)
   20 CONTINUE
      AP1(I,J,K) = AP + AP0(I,J,K)
      B(I,J,K) = Q(I,J,K) + AP0(I,J,K) * H0(I,J,K)
   10 CONTINUE
      RETURN
      END
C&QKOEFT
C **********************************************************************
C     Version 30081987  Subroutine QKOEFT
C **********************************************************************
C
C *** Subroutine QKOEFT Berechnung des Quelltermkoeffizienten  Temp. ***
C
      SUBROUTINE QKOEFT
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION AP1(IX,IY,IZ),AP0(IX,IY,IZ),ANB(IX,IY,IZ,KD),
     &          FNB(KD),DNB(KD),PECL(KD),B(IX,IY,IZ)
      COMMON /ENER/SC,SP,FRO
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /KOEF/AP1,AP0,ANB,FNB,DNB,PECL,B
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /TEMP/T,T0,STMP
C
      IF (IECHO.GE.1) CALL ROUTIN ('QKOEFT')
C
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      DO 10 I = 1, NX
C
C *** konstante Temperatur - Knoten ************************************
C
      IF (IFLAG(I,J,K).EQ.2.OR.IFLAG(I,J,K).EQ.5) THEN
         B(I,J,K) = AP0(I,J,K) * T0(I,J,K)
      ELSE
C
C *** nur Diffusion ****************************************************
C
         IF (IDIF.EQ.0) THEN
            B(I,J,K) = SC(I,J,K) * DXYZ(I,J,K) + AP0(I,J,K) * T0(I,J,K)
         ELSE
C
C *** Diffusion und Konvektion *****************************************
C
            TDIF = T(I,J,K) - STMP(K)
            IF (TDIF.GT.0.) THEN
               CPP = CPW * SATU(K) + (1. - SATU(K)) * CPL
            ELSE
               CALL WCPH2O (CPF,TDIF,K)
               CPP = CPF * SATU(K) + (1. - SATU(K)) * CPL
            END IF
            CC =  PHIG(I,J,K) * CPP + (1. - PHIG(I,J,K)) * CPG(I,J,K)
            IF (CC.EQ.0.) CC = 1. 
            B(I,J,K) = SC(I,J,K) / CC * DXYZ(I,J,K) + AP0(I,J,K) *
     &                 T0(I,J,K)
         END IF
      END IF   
   10 CONTINUE
      RETURN
      END
C&READMD
C **********************************************************************
C     Version 14041989  Subroutine READMD
C **********************************************************************
C
C *** Subroutine READMD Lesen einer dreidimensionalen Matrix ***********
C
      SUBROUTINE READMD (DM,IX,IY,IZ)
      DOUBLE PRECISION DM
      CHARACTER FORMIN*20
      DIMENSION DM(IX,IY,IZ)
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      READ (5,100) FORMIN
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      READ (5,FORMIN,END=50,ERR=50) (DM(I,J,K),I = 1, NX)
   10 CONTINUE
      RETURN
   50 STOP 'Datenfehler in Routine READMD'   
  100 FORMAT(A20)
      END
C&READMI
C **********************************************************************
C     Version 14041989  Subroutine READMI
C **********************************************************************
C
C *** Subroutine READMD Lesen einer dreidimensionalen Matrix ***********
C
      SUBROUTINE READMI (IM,IX,IY,IZ)
      CHARACTER FORMIN*20
      DIMENSION IM(IX,IY,IZ)
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      READ (5,100) FORMIN
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      READ (5,FORMIN,END=50,ERR=50) (IM(I,J,K),I = 1, NX)
   10 CONTINUE
      RETURN
   50 STOP 'Datenfehler in Routine READIM'   
  100 FORMAT(A20)
      END
C&READMR
C **********************************************************************
C     Version 14041989  Subroutine READMR
C **********************************************************************
C
C *** Subroutine READMR Lesen einer dreidimensionalen Matrix ***********
C
      SUBROUTINE READMR (RM,IX,IY,IZ)
      CHARACTER FORMIN*20
      DIMENSION RM(IX,IY,IZ)
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      READ (5,100) FORMIN
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      READ (5,FORMIN,END=50,ERR=50) (RM(I,J,K),I = 1, NX)
   10 CONTINUE
      RETURN
   50 STOP 'Datenfehler in Routine READMR'   
  100 FORMAT(A20)
      END
C&RICHTG
C **********************************************************************
C     Version 20101987  Subroutine RICHTG
C **********************************************************************
C
C *** Subroutine RICHTG Bestimmung der Iterationsreihenfolge ***********
C
      SUBROUTINE RICHTG (L,LANF,LEND,LPLUS,LW,L10)
      L01 = IABS(L10 - 1)
      LL = MOD(L+1,2) * (LW - 1)
      LANF = (LL + 1) * L10 + L01
      LEND = (LW - LL) * L10 + LW * L01
      LPLUS = (MOD(L,2) - MOD(L+1,2)) * L10 + L01
      RETURN
      END
C&ROUTIN
C **********************************************************************
C     Version 02081988  Subroutine ROUTIN
C **********************************************************************
C
C *** Subroutine ROUTIN Ausgabe der aktiven Subroutine *****************
C
      SUBROUTINE ROUTIN (SUBROU)
      CHARACTER SUBROU*6
      WRITE (1,100) SUBROU
      RETURN
  100 FORMAT(T17,'********* Subroutine ',A6,' **********')
      END
C&TAUPKT
C **********************************************************************
C     Version 24061987  Subroutine TAUPKT
C **********************************************************************
C
C *** Subroutine TAUPKT Gefrierpunktberechnung von Wasser **************
C
      SUBROUTINE TAUPKT (STMP,ZKOR,I,J)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION STMP
      DIMENSION ZKOR(IZ),STMP(IZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /WPOT/H,H0
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
C
      IF (IECHO.GE.1) CALL ROUTIN ('TAUPKT')
C
C *** exakte Loesung noch nicht vorhanden *****************************
C
      FLUR = FLURAB
      DO 10 K = 1, NZ
      IF (IGWF.EQ.1) FLUR = HOENN - H(I,J,K)
      IF (ZKOR(K).LE.FLUR) STMP(K) = 273.15
      IF (ZKOR(K).GT.FLUR) STMP(K) = 272.15
   10 CONTINUE
      RETURN
      END
C&THOMAS
C **********************************************************************
C     Version 21071988  Subroutine THOMAS
C **********************************************************************
C
C *** Subroutine THOMAS Tridiagonaler Matrizzenalgorithmus nach THOMAS *
C
      SUBROUTINE THOMAS (N)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      DOUBLE PRECISION UU,AA,BB,CC,DD,BETA,GAMMA,S,U
      DIMENSION UU(IMAX),AA(IMAX),BB(IMAX),CC(IMAX),DD(IMAX)
      DIMENSION GAMMA(0:IMAX),S(0:IMAX)
      COMMON /IADI/UU,AA,BB,CC,DD
      DO 10 I = 1, N
         BETA = BB(I) - AA(I) * GAMMA(I-1)
         IF (BETA.EQ.0.) THEN
            GAMMA(I) = 0.
            S(I) = UU(I)
         ELSE
            GAMMA(I) = CC(I) / BETA
            S(I) = (DD(I) - AA(I) * S(I-1)) / BETA
         END IF
   10 CONTINUE
C
C *** Wiedereinsetzen **************************************************
C
      UU(N) = S(N)
      DO 20 I = N-1, 1, -1
         UU(I) = S(I) - GAMMA(I) * UU(I+1)
   20 CONTINUE
      RETURN
      END
C&TMPDRU
C **********************************************************************
C     Version 14061987  Subroutine TMPDRU
C **********************************************************************
C
C *** Subroutine TMPDRU Drucken der berechneten Temperaturprofile ******
C
      SUBROUTINE TMPDRU
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /TEMP/T,T0,STMP
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /IPRO/IPROX,IPROY,IPROZ
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
C
      IF (IECHO.GE.1) CALL ROUTIN ('TMPDRU')
C
      CALL ZEITBE (IAUS)
      WRITE (IAUS,120) NIT
      IF (IPROY.EQ.0.OR.IPROY.GT.NY) GO TO 45
C *** X - Z  Schnitt ***************************************************
      WRITE (IAUS,20) YKOR(IPROY),IPROY
      WRITE (IAUS,30) (XKOR(I),I = 1, NX)
      DO 40 K = 1, NZ
      WRITE (IAUS,50) ZKOR(K),(CELS(T(I,IPROY,K)),I = 1, NX)
   40 CONTINUE
   45 IF (IPROX.EQ.0.OR.IPROX.GT.NX) GO TO 85
C *** Y - Z  Schnitt ***************************************************
      WRITE (IAUS,60) XKOR(IPROX),IPROX
      WRITE (IAUS,70) (YKOR(J),J = 1, NY)
      DO 80 K = 1, NZ
      WRITE (IAUS,50) ZKOR(K),(CELS(T(IPROX,J,K)),J = 1, NY)
   80 CONTINUE
   85 IF (IPROZ.EQ.0.OR.IPROZ.GT.NZ) GO TO 115
C *** X - Y Schnitt ****************************************************
      WRITE (IAUS,90) ZKOR(IPROZ),IPROZ
      WRITE (IAUS,100) (XKOR(I),I = 1, NX)
      DO 110 J = 1, NY
      WRITE (IAUS,50) YKOR(J),(CELS(T(I,J,IPROZ)),I = 1, NX)
  110 CONTINUE
   20 FORMAT(/,T20,'X - Z Temperaturverteilung Y bei ',F7.2,
     &       ' Meter - Spalte ',I2,/)
   30 FORMAT('  Z\X     ',10F7.2,/,50(10X,10F7.2,/))
   50 FORMAT(F10.2,10F7.2,/,50(10X,10F7.2,/))
   60 FORMAT(/,T20,'Y - Z Temperaturverteilung X bei ',F7.2,
     &       ' Meter - Reihe ',I2,/)
   70 FORMAT('  Z\Y     ',10F7.2,/,50(10X,10F7.2,/))
   90 FORMAT(/,T20,'X - Y Temperaturverteilung Z bei ',F7.2,
     &       ' Meter - Schicht ',I2,/)
  100 FORMAT('  Y\X     ',10F7.2,/,50(10X,10F7.2,/))
  120 FORMAT(/,' Konvergenz seit dem letzten Zeitschritt nach',I4,
     &       ' Iterationen')
  115 RETURN
      END
C&UMWAND
C **********************************************************************
C     Version 24091987  Subroutine UMWAND
C **********************************************************************
C
C *** Subroutine UMWAND Umwandeln der Zusatzinformationen **************
C
      SUBROUTINE UMWAND (L,IAN)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      DOUBLE PRECISION T,T0,STMP,CELV
      CHARACTER FLAG*4,FLG*4,UFLS*4
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION TTX(KX,KY,KZ),TTY(KX,KY,KZ),TTZ(KX,KY,KZ),
     &          SK(KX,KY,KZ),Q(KX,KY,KZ)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      COMMON /ENER/SC,SP,FRO
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /TEMP/T,T0,STMP
      COMMON /TRNS/TTX,TTY,TTZ,Q,SK
      COMMON /WPOT/H,H0
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
      CELVIN = 273.15
      ZAHL = WERT(L)
      FLG = FLAG(L)
C
      IF (IAN.GT.-1) GO TO 10
      IF (FLG.EQ.'CPGE') CALL UMWREA (CPG,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'GWNB') CALL UMWREA (Q,L,ZAHL,1,1,1,0,0)
      IF (FLG.EQ.'GWVX') CALL UMWREA (VX,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'GWVY') CALL UMWREA (VY,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'GWVZ') CALL UMWREA (VZ,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'HTOT') THEN
         CALL UMWREA (TTX,L,0.,0,0,0,0,0)
         CALL UMWREA (TTY,L,0.,0,0,0,0,0)
         CALL UMWREA (TTZ,L,0.,0,0,0,0,0)
         CALL UMWREA (SK,L,ZZZZ,0,0,0,0,0)
         CALL UMWREA (PHIN,L,ZZZZ,0,0,0,0,0)
         CALL UMWREA (H,L,999.,0,0,0,0,0)
         CALL UMWREA (H0,L,999.,0,0,0,0,0)
         CALL UMWINT (JFLAG,L,2.)
      END IF
      IF (FLG.EQ.'LEAK') THEN
         DELZ = DIFZ(IZZ(L))
         CALL UMWREA (TTZ,L,ZAHL * DELZ,0,0,0,0,0)
         IZZ(L) = IZZ(L) + 1
         CALL UMWREA (TTZ,L,ZAHL * DELZ,0,0,0,0,0)
         IZZ(L) = IZZ(L) - 1
      END IF
      IF (FLG.EQ.'PHIG') CALL UMWREA (PHIG,L,ZAHL / 100.,0,0,0,0,0)
      IF (FLG.EQ.'PHIN') CALL UMWREA (PHIN,L,ZAHL / 100.,0,0,0,0,0)
      IF (FLG.EQ.'RHOG') CALL UMWREA (RHOG,L,ZAHL * 1000.,0,0,0,0,0)
      IF (FLG.EQ.'RNZF') CALL UMWREA (Q,L,ZAHL,1,0,0,0,0)
      IF (FLG.EQ.'SPEI') CALL UMWREA (SK,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'TEMP') THEN
         CALL UMWDBL (T,L,ZAHL+CELVIN)
         CALL UMWDBL (T0,L,ZAHL+CELVIN)
      END IF
      IF (FLG.EQ.'TXYZ') THEN
         CALL UMWREA (TTX,L,ZAHL,0,0,0,0,0)
         CALL UMWREA (TTY,L,ZAHL,0,0,0,0,0)
         CALL UMWREA (TTZ,L,ZAHL,0,0,0,0,0)
      END IF
      IF (FLG.EQ.'TRSX') CALL UMWREA (TTX,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'TRSY') CALL UMWREA (TTY,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'TRSZ') CALL UMWREA (TTZ,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'TTOT') THEN
         CALL UMWREA (SC,L,0.,0,0,0,0,0)
         CALL UMWREA (WLKG,L,0.,0,0,0,0,0)
         CALL UMWREA (PHIG,L,0.,0,0,0,0,0)
         CALL UMWREA (PHIN,L,0.,0,0,0,0,0)
         CALL UMWREA (CPG,L,ZZZZ,0,0,0,0,0)
         CALL UMWDBL (T,L,999.+CELVIN)
         CALL UMWDBL (T0,L,999.+CELVIN)
         CALL UMWINT (IFLAG,L,2.)
      END IF
      IF (FLG.EQ.'WLKG') CALL UMWREA (WLKG,L,ZAHL,0,0,0,0,0)
      IF (FLG.EQ.'WPOT') THEN
         CALL UMWREA (H,L,ZAHL,0,0,0,0,0)
         CALL UMWREA (H0,L,ZAHL,0,0,0,0,0)
      END IF
   10 IF (IABS(IAN).GT.0) THEN
        IF (FLG.EQ.'IFLG') CALL UMWINT (IFLAG,L,ZAHL)
        IF (FLG.EQ.'JFLG') CALL UMWINT (JFLAG,L,ZAHL)
        IF (FLG.EQ.'QUEL') CALL UMWREA (Q,L,ZAHL,0,0,0,0,0)
        IF (FLG.EQ.'SOUC') CALL UMWREA (SC,L,ZAHL,0,0,0,0,0)
        IF (FLG.EQ.'WATT') CALL UMWREA (SC,L,ZAHL,0,0,0,0,1)
        IF (FLG.EQ.'WPXM') CALL UMWREA (SC,L,ZAHL,0,1,0,0,1)
        IF (FLG.EQ.'WPYM') CALL UMWREA (SC,L,ZAHL,0,0,1,0,1)
        IF (FLG.EQ.'WPZM') CALL UMWREA (SC,L,ZAHL,0,0,0,1,1)
        IF (FLG.EQ.'WPXY') CALL UMWREA (SC,L,ZAHL,0,1,1,0,1)
        IF (FLG.EQ.'WPXZ') CALL UMWREA (SC,L,ZAHL,0,1,0,1,1)
        IF (FLG.EQ.'WPYZ') CALL UMWREA (SC,L,ZAHL,0,0,1,1,1)
        IF (FLG.EQ.'TEMP') THEN
           CALL UMWDBL (T,L,ZAHL+CELVIN)
           CALL UMWDBL (T0,L,ZAHL+CELVIN)
        END IF
      END IF
      IF (IAN.EQ.0.AND.IDATOP.EQ.0) THEN
        IF (FLG.EQ.'QUEL') CALL UMWREA (Q,L,-ZAHL,1,0,0,0,0)
        IF (FLG.EQ.'SOUC') CALL UMWREA (SC,L,0.,0,0,0,0,0)
        IF (FLG.EQ.'WATT') CALL UMWREA (SC,L,0.,0,0,0,0,0)
        IF (FLG.EQ.'IFLG') CALL UMWINT (IFLAG,L,1.)
        IF (FLG.EQ.'JFLG') CALL UMWINT (JFLAG,L,1.)
      END IF
      RETURN
      END
C&UMWREA
C **********************************************************************
C     Version 20051988  Subroutine UMWREA
C **********************************************************************
C
C *** Subroutine UMWREA Umwandeln der REAL - Felder ********************
C
      SUBROUTINE UMWREA (FELD,L,ZAHL,ISUP,IFAK,JFAK,KFAK,IDVOL)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      CHARACTER FLAG*4,UFLS*4
      DIMENSION FELD(IX,IY,IZ)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
C
      IUF = IABS(IUFL(L)) + 1
      IF (IUFL(L).LT.0) ISUP = 1
      GO TO (100,200,300,400,500,600,700,800) IUF
C
C
C *** nur einen Knoten besetzen ****************************************
C
  100 ZAHL1 = ZAHL * DELTAX(IXX(L))             ** IFAK 
     &             * DELTAY(IYY(L))             ** JFAK 
     &             * DELTAZ(IZZ(L))             ** KFAK 
     &             / DXYZ(IXX(L),IYY(L),IZZ(L)) ** IDVOL
      FELD(IXX(L),IYY(L),IZZ(L)) = FELD(IXX(L),IYY(L),IZZ(L)) * ISUP
     &                           + ZAHL1
      RETURN
C
C *** nur die X - Saeule besetzen **************************************
C
  200 DO 20 I = 1, NX
      ZAHL1 = ZAHL * DELTAX(I)             ** IFAK 
     &             * DELTAY(IYY(L))        ** JFAK 
     &             * DELTAZ(IZZ(L))        ** KFAK 
     &             / DXYZ(I,IYY(L),IZZ(L)) ** IDVOL
      FELD(I,IYY(L),IZZ(L)) = FELD(I,IYY(L),IZZ(L)) * ISUP + ZAHL1
   20 CONTINUE
      RETURN
C
C *** nur die Y - Saeule besetzen **************************************
C
  300 DO 30 J = 1, NY
      ZAHL1 = ZAHL * DELTAX(IXX(L))        ** IFAK 
     &             * DELTAY(J)             ** JFAK 
     &             * DELTAZ(IZZ(L))        ** KFAK 
     &             / DXYZ(IXX(L),J,IZZ(L)) ** IDVOL
      FELD(IXX(L),J,IZZ(L)) = FELD(IXX(L),J,IZZ(L)) * ISUP + ZAHL1
   30 CONTINUE
      RETURN
C
C *** nur die Z - Saeule besetzen **************************************
C
400   DO 40 K = 1, NZ
      ZAHL1 = ZAHL * DELTAX(IXX(L))        ** IFAK 
     &             * DELTAY(IYY(L))        ** JFAK 
     &             * DELTAZ(K)             ** KFAK 
     &             / DXYZ(IXX(L),IYY(L),K) ** IDVOL
      FELD(IXX(L),IYY(L),K) = FELD(IXX(L),IYY(L),K) * ISUP + ZAHL1
   40 CONTINUE
      RETURN
C
C *** nur die X/Y - Ebene besetzen *************************************
C
  500 DO 50 J = 1, NY
      DO 50 I = 1, NX
      ZAHL1 = ZAHL * DELTAX(I)        ** IFAK 
     &             * DELTAY(J)        ** JFAK 
     &             * DELTAZ(IZZ(L))   ** KFAK 
     &             / DXYZ(I,J,IZZ(L)) ** IDVOL
      FELD(I,J,IZZ(L)) = FELD(I,J,IZZ(L)) * ISUP + ZAHL1
   50 CONTINUE
      RETURN
C
C *** nur die X/Z - Ebene besetzen *************************************
C
  600 DO 60 I = 1, NX
      DO 60 K = 1, NZ
      ZAHL1 = ZAHL * DELTAX(I)        ** IFAK 
     &             * DELTAY(IYY(L))   ** JFAK 
     &             * DELTAZ(K)        ** KFAK 
     &             / DXYZ(I,IYY(L),K) ** IDVOL
      FELD(I,IYY(L),K) = FELD(I,IYY(L),K) * ISUP + ZAHL1
   60 CONTINUE
      RETURN
C
C *** nur die Y/Z - Ebene besetzen *************************************
C
  700 DO 70 J = 1, NY
      DO 70 K = 1, NZ
      ZAHL1 = ZAHL * DELTAX(IXX(L))   ** IFAK 
     &             * DELTAY(J)        ** JFAK 
     &             * DELTAZ(K)        ** KFAK 
     &             / DXYZ(IXX(L),J,K) ** IDVOL
      FELD(IXX(L),J,K) = FELD(IXX(L),J,K) * ISUP + ZAHL1
   70 CONTINUE
      RETURN
C
C *** das gesamte Modellnetz besetzen  *********************************
C
  800 DO 80 J = 1, NY
      DO 80 I = 1, NX
      DO 80 K = 1, NZ
      ZAHL1 = ZAHL * DELTAX(I)      ** IFAK 
     &             * DELTAY(J)      ** JFAK 
     &             * DELTAZ(K)      ** KFAK 
     &             / DXYZ(I,J,K)    ** IDVOL
      FELD(I,J,K) = FELD(I,J,K) * ISUP + ZAHL1
   80 CONTINUE
      RETURN
      END
C&UMWDBL
C **********************************************************************
C     Version 20051988  Subroutine UMWDBL
C **********************************************************************
C
C *** Subroutine UMWDBL Umwandeln der DOUBLE PRECISION - Felder ********
C
      SUBROUTINE UMWDBL (FELD,L,ZAHL)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      DOUBLE PRECISION FELD
      CHARACTER FLAG*4,UFLS*4
      DIMENSION FELD(IX,IY,IZ)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
      GO TO (100,200,300,400,500,600,700,800) IUFL(L) + 1
  100 FELD(IXX(L),IYY(L),IZZ(L)) = ZAHL
      RETURN
  200 DO 20 I = 1, NX
      FELD(I,IYY(L),IZZ(L)) = ZAHL
   20 CONTINUE
      RETURN
  300 DO 30 J = 1, NY
      FELD(IXX(L),J,IZZ(L)) = ZAHL
   30 CONTINUE
      RETURN
  400 DO 40 K = 1, NZ
      FELD(IXX(L),IYY(L),K) = ZAHL
   40 CONTINUE
      RETURN
  500 DO 50 J = 1, NY
      DO 50 I = 1, NX
      FELD(I,J,IZZ(L)) = ZAHL
   50 CONTINUE
      RETURN
  600 DO 60 I = 1, NX
      DO 60 K = 1, NZ
      FELD(I,IYY(L),K) = ZAHL
   60 CONTINUE
      RETURN
  700 DO 70 J = 1, NY
      DO 70 K = 1, NZ
      FELD(IXX(L),J,K) = ZAHL
   70 CONTINUE
      RETURN
  800 DO 80 K = 1, NZ
      DO 80 J = 1, NY
      DO 80 I = 1, NX
      FELD(I,J,K) = ZAHL
   80 CONTINUE
      RETURN
      END
C&UMWINT
C **********************************************************************
C     Version 20051988  Subroutine UMWINT
C **********************************************************************
C
C *** Subroutine UMWINT Umwandeln der INTEGER - Felder *****************
C
      SUBROUTINE UMWINT (IFELD,L,ZAHL)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      PARAMETER (IWERT=5000,IKEYS=31)
      CHARACTER FLAG*4,UFLS*4
      DIMENSION IFELD(IX,IY,IZ)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
      GO TO (100,200,300,400,500,600,700,800) IUFL(L) + 1
  100 IFELD(IXX(L),IYY(L),IZZ(L)) = INT(ZAHL)
      RETURN
  200 DO 20 I = 1, NX
      IFELD(I,IYY(L),IZZ(L)) = INT(ZAHL)
   20 CONTINUE
      RETURN
  300 DO 30 J = 1, NY
      IFELD(IXX(L),J,IZZ(L)) = INT(ZAHL)
   30 CONTINUE
      RETURN
  400 DO 40 K = 1, NZ
      IFELD(IXX(L),IYY(L),K) = INT(ZAHL)
   40 CONTINUE
      RETURN
  500 DO 50 J = 1, NY
      DO 50 I = 1, NX
      IFELD(I,J,IZZ(L)) = INT(ZAHL)
   50 CONTINUE
      RETURN
  600 DO 60 I = 1, NX
      DO 60 K = 1, NZ
      IFELD(I,IYY(L),K) = INT(ZAHL)
   60 CONTINUE
      RETURN
  700 DO 70 J = 1, NY
      DO 70 K = 1, NZ
      IFELD(IXX(L),J,K) = INT(ZAHL)
   70 CONTINUE
      RETURN
  800 DO 80 K = 1, NZ
      DO 80 J = 1, NY
      DO 80 I = 1, NX
      IFELD(I,J,K) = INT(ZAHL)
   80 CONTINUE
      RETURN
      END
C&VISKOS
C **********************************************************************
C     Version 06051988  Subroutine VISKOS
C **********************************************************************
C
C *** Subroutine VISKOS Berechnung der kinem. Viskositaet von Wasser ***
C
      SUBROUTINE VISKOS (I,J,K,VISX,VISY,VISZ)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      COMMON /TEMP/T,T0,STMP
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      VISX = 1.
      VISY = 1.
      VISZ = 1.
      T1 = REAL(T(I,J,K))
C
C *** ... des in X - Richtung fliessenden Wassers **********************
C
      IF (I.EQ.NX) GO TO 10
      T2 = REAL(T(I+1,J,K))
      IF (VX(I,J,K).EQ.0.) THEN
         CALL HARMON (T1,T2,TT,FX(I))
      ELSE
         IF (VX(I,J,K).GT.0.) THEN
            TT = T1
         ELSE
            TT = T2
         END IF
      END IF
      VISX = VISKIN(TT)
   10 CONTINUE
C
C *** ... des in Y - Richtung fliessenden Wassers **********************
C
      IF (J.EQ.NY) GO TO 20
      T2 = REAL(T(I,J+1,K))
      IF (VY(I,J,K).EQ.0.) THEN
         CALL HARMON (T1,T2,TT,FY(J))
      ELSE
         IF (VY(I,J,K).GT.0.) THEN
            TT = T1
         ELSE
            TT = T2
         END IF
      END IF
      VISY = VISKIN(TT)
   20 CONTINUE
C
C *** ... des in Z - Richtung fliessenden Wassers **********************
C
      IF (K.EQ.NZ) GO TO 30
      T2 = REAL(T(I,J,K+1))
      IF (VZ(I,J,K).EQ.0.) THEN
         CALL HARMON (T1,T2,TT,FZ(K))
      ELSE
         IF (VZ(I,J,K).GT.0.) THEN
            TT = T1
         ELSE
            TT = T2
         END IF
      END IF
      VISZ = VISKIN(TT)
   30 CONTINUE
      RETURN
      END
C&VDRUCK
C **********************************************************************
C     Version 12101987  Subroutine VDRUCK
C **********************************************************************
C
C *** Subroutine VDRUCK Drucken des Grundwasserfliessgeschwindigkeiten *
C
      SUBROUTINE VDRUCK
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
C
      IF (IECHO.GE.1) CALL ROUTIN ('VDRUCK')
C
      WRITE (IAUS,100)
      WRITE (IAUS,110)
      WRITE (IAUS,120)
      DO 10 K = 1, NZ
      WRITE (IAUS,130) ZKOR(K),SATU(K) * 100.,
     &                 VX(1,1,K),VY(1,1,K),VZ(1,1,K)
   10 CONTINUE
  100 FORMAT(' Grundwasserfliessgeschwindigkeit in m/s:',/)
  110 FORMAT(' Tiefe (m)     Saettigung      X-Richtung     Y-Richtung
     &   Z-Richtung')
  120 FORMAT(1H ,70(1H-))
  130 FORMAT(F8.2,8X,F7.2,6X,3(1PE11.3,4X))
      RETURN
      END
C&WARMIN
C **********************************************************************
C     Version 15021988  Subroutine WARMIN
C **********************************************************************
C
C *** Subroutine WARMIN liest das Ergebnis der vorherigen Simulation ***
C
      SUBROUTINE WARMIN
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELV
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
C
      IF (IECHO.GE.1) CALL ROUTIN ('WARMIN')
C
      OPEN(9,FILE='TRADWS',STATUS='OLD',ERR=100)
      IF (IGWF.LE.1) THEN
         DO 10 K = 1, NZ
         DO 10 J = 1, NY
         READ (9,400,ERR=200,END=300) (T(I,J,K),I = 1, NX)
         DO 10 I = 1, NX
         T(I,J,K) = CELV(T(I,J,K))
   10    CONTINUE
      END IF
      IF (IGWF.GE.1) THEN
         DO 20 K = 1, NZ
         DO 20 J = 1, NY
         READ (9,500,ERR=200,END=300) (H(I,J,K),I = 1, NX)
   20    CONTINUE
      END IF
      CLOSE(9)
      RETURN
  100 PRINT *,'Datei TRADWS nicht verhanden - Simulation abgebrochen'
      STOP
  200 PRINT *,'Fehler in der Datenstruktur der Datei TRADWS'
      STOP
  300 PRINT *,'Unerwartet das Ende der Datei TRADWS erreicht'
      STOP
  400 FORMAT(50(10F8.3,/))
  500 FORMAT(50(10F8.2,/))
      END
C&WARMOU
C **********************************************************************
C     Version 15021988  Subroutine WARMOU
C **********************************************************************
C
C *** Subroutine WARMOU schreibt Zwischenergebnis fuer einen Warmstart *
C
      SUBROUTINE WARMOU
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP,CELS
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /TEMP/T,T0,STMP
      COMMON /WPOT/H,H0
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
C
      IF (IECHO.GE.1) CALL ROUTIN ('WARMOU')
C
      OPEN(9,FILE='TRADWS')
      IF (IGWF.LE.1) THEN
         DO 10 K = 1, NZ
         DO 10 J = 1, NY
         WRITE (9,100) (CELS(T(I,J,K)),I = 1, NX)
   10    CONTINUE
      END IF
C
C *** Piezometerhoehen ... *********************************************
C
      IF (IGWF.GE.1) THEN
         DO 20 K = 1, NZ
         DO 20 J = 1, NY
         WRITE (9,200) (H(I,J,K),I = 1, NX)
   20    CONTINUE
         IF (IGWF.EQ.1) THEN
C
C *** Fliessgeschwindigkeit in X - Richtung ****************************
C
         DO 30 K = 1, NZ
         DO 30 J = 1, NY
         WRITE (9,300) (VX(I,J,K),I = 1, NX)
   30    CONTINUE
C
C *** Fliessgeschwindigkeit in Y - Richtung ****************************
C
         DO 40 K = 1, NZ
         DO 40 J = 1, NY
         WRITE (9,300) (VY(I,J,K),I = 1, NX)
   40    CONTINUE
C
C *** Fliessgeschwindigkeit in Z - Richtung ****************************
C
         DO 50 K = 1, NZ
         DO 50 J = 1, NY
         WRITE (9,300) (VZ(I,J,K),I = 1, NX)
   50    CONTINUE
      END IF
      END IF
      CLOSE(9)
      RETURN
  100 FORMAT(50(10F8.3,/))
  200 FORMAT(50(10F8.2,/))
  300 FORMAT(50(10(1PE9.2),/))
      END
C&WASEIS
C **********************************************************************
C     Version 19121988  Subroutine WASEIS
C **********************************************************************
C
C *** Subroutine WASEIS Berechnung der Wasser/Eis - Verhaeltnisses *****
C
      SUBROUTINE WASEIS (WE,TDIF,K)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      COMMON /ENER/SC,SP,FRO
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
C
      IF (IECHO.GE.2) CALL ROUTIN ('WASEIS')
C
      GO TO (10) IFRO(K)
      WE = 1.
      RETURN
C
C *** Gefriermodell 1:  Y = FRO(1) * EXP(FRO(2) * X) + FRO(3) **********
C
   10 WE = FRO(K,1) * EXP(FRO(K,2) * TDIF) + FRO(K,3)
      RETURN
      END
C&WCPH2O
C **********************************************************************
C     Version 19121988  Subroutine WCPH2O
C **********************************************************************
C
C *** Subroutine WCPH2O Berechnung der Waermekapazitaet von Wasser *****
C
      SUBROUTINE WCPH2O (CPWE,TDIF,K)
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /PAR4/DTW,DTW2,DWAN,DTWL(3)
C
      IF (IECHO.GE.2) CALL ROUTIN ('WCPH2O')
C
      IF (TDIF + DTW2.LE.0.) THEN
         CALL WASEIS (WE1,TDIF + DTW2,K)
         CALL WASEIS (WE2,TDIF - DTW2,K)
         DT = DTW
      ELSE
          WE1 = 1.
          CALL WASEIS (WE2,-DTW2,K)
          DT = DTW2
      END IF
      DWE  = WE1 - WE2
      DWEM = (WE1 + WE2) / 2.
      CPWE = CPW * DWEM + CPE * (1. - DWEM) + SENTHA * DWE / DT
      RETURN
      END
C&WFLUSS
C **********************************************************************
C     Version 21111987  Subroutine WFLUSS
C **********************************************************************
C
C *** Subroutine WFLUSS Berechnung des Waermeflusses zum Waermetauscher
C
      SUBROUTINE WFLUSS (IMAL)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DOUBLE PRECISION T,T0,STMP
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION IFLAG(IX,IY,IZ),JFLAG(KX,KY,KZ),IFLUS(JX,JY,JZ),IFRO(JZ)
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /IFLD/IFLAG,JFLAG,IFLUS,IFRO
      COMMON /TEMP/T,T0,STMP
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /NDIM/NX,NY,NZ,NX1,NY1,NZ1
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
C
      IF (IECHO.GE.1) CALL ROUTIN ('WFLUSS')
C
      IDIFF = IDIF
      WATT = 0.
      DO 10 K = 1, NZ
      DO 10 J = 1, NY
      DO 10 I = 1, NX
      IF (IFLAG(I,J,K).EQ.5) THEN
         IF (IDIFF.EQ.1) THEN
            IDIF = 0
            CALL KONINF (I,J,K)
            CALL KONINF (I-1,J,K)
            CALL KONINF (I,J-1,K)
            CALL KONINF (I,J,K-1)
        END IF
        IF (I.GT.1.AND.IFLAG(I-1,J,K).EQ.1)
     &     WATT = WATT + WTI(I-1,J,K,1) * DELTAY(J) * DELTAZ(K) *
     &            (T(I-1,J,K) - T(I,J,K)) / DIFX(I-1)
        IF (I.LT.NX.AND.IFLAG(I+1,J,K).EQ.1)
     &     WATT = WATT + WTI(I,J,K,1)   * DELTAY(J) * DELTAZ(K) *
     &            (T(I+1,J,K) - T(I,J,K)) / DIFX(I)
        IF (J.GT.1.AND.IFLAG(I,J-1,K).EQ.1)
     &     WATT = WATT + WTI(I,J-1,K,2) * DELTAX(I) * DELTAZ(K) *
     &            (T(I,J-1,K) - T(I,J,K)) / DIFY(J-1)
        IF (J.LT.NY.AND.IFLAG(I,J+1,K).EQ.1)
     &     WATT = WATT + WTI(I,J,K,2) * DELTAX(I) * DELTAZ(K) *
     &            (T(I,J+1,K) - T(I,J,K)) / DIFY(J)
        IF (K.GT.1.AND.IFLAG(I,J,K-1).EQ.1)
     &     WATT = WATT + WTI(I,J,K-1,3) * DELTAX(I) * DELTAY(J) *
     &            (T(I,J,K-1) - T(I,J,K)) / DIFZ(K-1)
        IF (K.LT.NZ.AND.IFLAG(I,J,K+1).EQ.1)
     &     WATT = WATT + WTI(I,J,K,3) * DELTAX(I) * DELTAY(J) *
     &            (T(I,J,K+1) - T(I,J,K)) / DIFZ(K)
      END IF
   10 CONTINUE
      IDIF = IDIFF
      WATPH = 3600. * WATT / DZEIT * IMAL
      WRITE (IAUS,110) WATT
      WRITE (IAUS,120) WATPH
  110 FORMAT(' Waermefluss zum Waermetauscher              ',1PE15.6,
     &       ' Watt')
  120 FORMAT(' Waermefluss pro Zeiteinheit                 ',1PE15.6,
     &       ' Watt/Stunde')
      RETURN
      END
C&WICHTP
C **********************************************************************
C     Version 03081988  Subroutine WICHTP
C **********************************************************************
C
C *** Subroutine WICHTP Wichtung zwischen Explizit- und Implizit-Schema
C
      SUBROUTINE WICHTP (I,J,K,TT)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      DOUBLE PRECISION T,T0,STMP,TT
      DIMENSION T(JX,JY,JZ),T0(JX,JY,JZ),STMP(JZ)
      COMMON /TEMP/T,T0,STMP
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      TT = ALFATP * T(I,J,K) + (1. - ALFATP) * T0(I,J,K)
      RETURN
      END
C&WICHHY
C **********************************************************************
C     Version 03081988  Subroutine WICHHY
C **********************************************************************
C
C *** Subroutine WICHHY Wichtung zwischen Explizit- und Implizit-Schema
C
      SUBROUTINE WICHHY (I,J,K,HH)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      DIMENSION H(KX,KY,KZ),H0(KX,KY,KZ)
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /WPOT/H,H0
      HH = ALFAHY * H(I,J,K) + (1. - ALFAHY) * H0(I,J,K)
      RETURN
      END
C&ZEITBE
C **********************************************************************
C     Version 13081987  Subroutine ZEITBE
C **********************************************************************
C
C *** Subroutine ZEITBE Ausgabe der abgelaufenen Zeit auf IUNIT ********
C
      SUBROUTINE ZEITBE (IUNIT)
C
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /PAR1/DZEIT,DZMF,DZF,FLURAB,ALFATP,FEHLT,FEHLER,OMGT,SUMSEK
      IF (IECHO.GE.1) CALL ROUTIN ('ZEITBE')
C
      ZSEC  =  SUMSEK
      ZMIN  =  ZSEC / 60.
      ZSTU  =  ZMIN / 60.
      ZTAG  =  ZSTU / 24.
      ZWOC  =  ZTAG /  7.
      ISEC  =  INT(ZSEC) - INT(ZMIN) * 60
      IMIN  =  INT(ZMIN) - INT(ZSTU) * 60
      ISTU  =  INT(ZSTU) - INT(ZTAG) * 24
      ITAG  =  INT(ZTAG) - INT(ZWOC) *  7
      IWOC  =  INT(ZWOC)
      IF (IUNIT.GT.1) WRITE (IUNIT,10) IWOC,ITAG,ISTU,IMIN,ISEC
      IF (IUNIT.EQ.1.AND.IECHO.GE.1)
     &   WRITE (IUNIT,20) IWOC,ITAG,ISTU,IMIN,ISEC
      IF (IUNIT.EQ.1.AND.IECHO.EQ.0)
     &   WRITE (IUNIT,30) IWOC,ITAG,ISTU,IMIN,ISEC,NIT
   10 FORMAT(/,' Temperaturverteilung nach ',I3,' Wochen ',I2,' Tagen ',
     &         I2,' Stunden ',I2,' Minuten ',I2,' Sekunden',/)
   20 FORMAT(' Abgelaufene Zeit: ',I3,' Wochen ',I2,' Tagen ',
     &         I2,' Stunden ',I2,' Minuten ',I2,' Sekunden')
   30 FORMAT(1H+,' Abgelaufene Zeit: ',I3,' Wochen ',I2,' Tagen ',
     &         I2,' Stunden ',I2,' Min. ',I2,' Sek. NIT = ',I3,' ')
      RETURN
      END
C&ZELLEN
C **********************************************************************
C     Version 18081987  Subroutine ZELLEN
C **********************************************************************
C
C *** Subroutine ZELLEN Berechnung der Waermeenergie der Zelle (I,J,K) *
C
      SUBROUTINE ZELLEN (I,J,K,TEMP,STEMP)
      PARAMETER (IX=100,IY=100,IZ=10,IMAX=100,KD=6,KD2=KD/2)
      PARAMETER (IP1=1,IP2=1,IQ1=0,IQ2=0)
      PARAMETER (JX=IX*IP1+IQ1,JY=IY*IP1+IQ1,JZ=IZ*IP1+IQ1)
      PARAMETER (KX=IX*IP2+IQ2,KY=IY*IP2+IQ2,KZ=IZ*IP2+IQ2)
      IMPLICIT DOUBLE PRECISION (E)
      DOUBLE PRECISION TEMP,STEMP
      DIMENSION DELTAX(IX),DELTAY(IY),DELTAZ(IZ),DIFX(IX),DIFY(IY),
     &          DIFZ(IZ),XKOR(IX),YKOR(IY),ZKOR(IZ),DIVX(IX,2),
     &          DIVY(IY,2),DIVZ(IZ,2),FX(IX),FY(IY),FZ(IZ),
     &          DXYZ(IX,IY,IZ)
      DIMENSION CPG(JX,JY,JZ),WLKG(JX,JY,JZ),WTI(IX,IY,IZ,KD2),
     &          RHOG(JX,JY,JZ),PHIG(JX,JY,JZ),PHIN(IX,IY,IZ),
     &          SATU(IZ),VX(IX,IY,IZ),VY(IX,IY,IZ),VZ(IX,IY,IZ),ANISO(3)
      DIMENSION SC(JX,JY,JZ),SP(JX,JY,JZ),FRO(JZ,5)
      COMMON /GITT/DELTAX,DELTAY,DELTAZ,DIFX,DIFY,DIFZ,XKOR,YKOR,ZKOR,
     &             DIVX,DIVY,DIVZ,FX,FY,FZ,DXYZ
      COMMON /ENER/SC,SP,FRO
      COMMON /PHYS/CPG,WLKG,ANISO,WTI,RHOG,PHIG,PHIN,SATU,VX,VY,VZ
      COMMON /PAR3/CPW,CPE,CPL,WLW,WLE,WLL,RHOW,RHOE,RHOL,SENTHA
      COMMON /EKAL/EALT,EANF,ESUM
      VOLW = DXYZ(I,J,K) *  PHIG(I,J,K) * SATU(K)
      VOLL = DXYZ(I,J,K) *  PHIG(I,J,K) * (1. - SATU(K))
      VOLG = DXYZ(I,J,K) * (1. - PHIG(I,J,K))
      IF (TEMP - STEMP) 10,10,20
C
C *** ... gefroren oder teilgefroren **********************************
C
   10 TDIF = TEMP - STEMP
      CALL WASEIS (WE,TDIF,K)
      SENT = WE * SENTHA * VOLW * RHOW
      ESUM = TEMP * (VOLW * (WE * CPW * RHOW + (1. - WE) * CPE * RHOE)
     &            +  VOLL * CPL * RHOL 
     &            +  VOLG * RHOG(I,J,K) * CPG(I,J,K))
     &            +  SENT
      RETURN
C
C *** ... fluessig ****************************************************
C
   20 SENT = SENTHA * VOLW * RHOW
      ESUM = TEMP * (VOLW * RHOW * CPW
     &            +  VOLL * RHOL * CPL
     &            +  VOLG * RHOG(I,J,K) * CPG(I,J,K))
     &            +  SENT
      RETURN
      END
C&ZUSDAT
C **********************************************************************
C     Version 30111987  Subroutine ZUSDAT
C **********************************************************************
C
C *** Subroutine ZUSDAT Einlesen zusaetzlicher, zeitabhaengiger Daten **
C
      SUBROUTINE ZUSDAT (IEINS)
      PARAMETER (IWERT=5000,IKEYS=31)
      CHARACTER FLAG*4,FORMIN*20,UFLS*4
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      DIMENSION IXOBS(10),IYOBS(10),IZOBS(10)
      COMMON /INF1/IZEIT,IPECL,IVOLDF,IAUSOP,ILOOP,IEIN,INPOP,IALTER
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /INF4/IOBS,IXOBS,IYOBS,IZOBS,IWARMS,IWSDAT,IDSTOP,IGWF,
     &             IDZTST  
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
C
      IF (IECHO.GE.1) CALL ROUTIN ('ZUSDAT')
C
      IF (IEINS.EQ.0) THEN
         READ (8,100) FORMIN
         READ (8,FORMIN) LDAT
         IF (LUMW+LDAT.GT.IWERT) THEN
            WRITE (1,110) LUMW + LDAT
            CALL ZEITCL
            STOP
         END IF
         READ (8,100) FORMIN
         DO 10 L = LUMW + 1, LUMW + LDAT
            READ (8,FORMIN) FLAG(L),IXX(L),IYY(L),IZZ(L),IUFL(L)
   10    CONTINUE
         CALL CHECKU(0)
         READ (8,105) FORMIN
         IEINS = 1
      END IF
      READ (8,FORMIN,ERR=200,END=300) (WERT(LUMW+L), L = 1, LDAT)
      DO 20 L = 1, LDAT
         IF (WERT(LUMW+L).NE.ZIGNO) CALL UMWAND (LUMW+L,-1)
   20 CONTINUE
      RETURN
  200 WRITE (1,120)
      CALL ZEITCL
      STOP
  300 IF (IGWF.LE.1) CALL TMPDRU
      IF (IGWF.GE.1) CALL PIEDRU
      CALL ISODRV
      IF (IENER.EQ.1)  CALL ENERGI
      IF (IWSDAT.EQ.1) CALL WARMOU
      WRITE (1,130)
      CALL ZEITCL
      STOP
  100 FORMAT(A20)
  105 FORMAT(A20,/)
  110 FORMAT(' Es sollen ',I4,' Werte umgewandelt werden - Feld IWERT',
     &       ' zu klein dimensioniert')
  120 FORMAT(' Fehler in der Datenstruktur der Zusatzdaten')
  130 FORMAT(' Ende der optionalen Eingabedatei erreicht -',
     &       ' Bearbeitung abgebrochen')
      END
C&ZEITCL
C **********************************************************************
C     Version 27071993  Subroutine ZEITCL
C **********************************************************************
C
C *** Subroutine ZEITCL Ausgabe der Rechenzeit *************************
C
      SUBROUTINE ZEITCL
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /PAR2/BASIS,HOENN,ALFAHY,OMGH,FEHLH,ZZZZ,ZIGNO,RZEIT
C
      IF (IECHO.GE.1) CALL ROUTIN ('ZEITCL')
C
      CALL GETTIM (IHr, IMin, ISec, I100th)
      IZZZZ2 =  (IHr * 3600 + IMin * 60 + ISec) * 100 + I100th
      IF (IZZZZ2.GE.IZZZZ1) THEN
         RZEIT = RZEIT + (IZZZZ2-IZZZZ1)/100./60.
      ELSE
         RZEIT = RZEIT + (24*3600*100-IZZZZ1+IZZZZ2)/100./60.
      END IF
      WRITE (IAUS,100) RZEIT
      WRITE (1,100)    RZEIT
  100 FORMAT(T16,' Gesamtrechenzeit: ',F12.4,' Minuten')
      RETURN
      END
C&CKECKU
C **********************************************************************
C     Version 02081993  Subroutine CHECKU
C **********************************************************************
C
C *** Subroutine CHECKU Ueberpruefung der Umwandlungskeywoerter ********
C
      SUBROUTINE CHECKU (IKURZ)
      PARAMETER (IWERT=5000,IKEYS=31)
      CHARACTER TITEL*80,FLAG*4,UFLS*4
      DIMENSION INDX(6),INDY(6),INDZ(6),IADD(4),JADD(4),KADD(4)
      DIMENSION FORMOU(8),FORTXT(8)
      DIMENSION WERT(IWERT),IXX(IWERT),IYY(IWERT),IZZ(IWERT),
     &          FLAG(IWERT),IUFL(IWERT),UFLS(IKEYS)
      COMMON /INF2/IDIF,IDRU,IFROST,IAUS,IECHO,MODEL,NIT,IWCP,ISOR,IEN1
      COMMON /INF3/LUMW,IENER,ISTOP,IDATOP,LISDAT,IDZ,TST,IZZZZ1,LDAT
      COMMON /IZY1/IXX,IYY,IZZ,IUFL
      COMMON /ZYK1/WERT
      COMMON /ZYK2/FLAG,UFLS
C
      IF (IECHO.GE.1) CALL ROUTIN ('CHECKU')
C
      II1 = 1
      II2 = LUMW
      IF (IKURZ.EQ.0) THEN
          II1 = LUMW + 1
          II2 = LUMW + LDAT
      END IF
      IERR = 0
      DO 10 I = II1,II2
         IOK = 0
         DO 20 J=1,IKEYS
            IF (FLAG(I).EQ.UFLS(J)) IOK = 1
   20    CONTINUE
         IF (IOK.EQ.0) THEN
            WRITE (IAUS,100) I, FLAG(I)
            WRITE (1,100)    I, FLAG(I)
            IERR = IERR + 1
         END IF
   10 CONTINUE
      IF (IERR.GT.0) THEN
         IF (IKURZ.EQ.1) THEN
            WRITE (IAUS,200) IERR
            WRITE (1,200)    IERR
         ELSE
            WRITE (IAUS,300) IERR
            WRITE (1,300)    IERR
         END IF
         STOP ' Bitte ueberpruefen Sie die Eingabedatei!'
      END IF          
  100 FORMAT(T16,I4,'. Schluesselwort: ',A4,' unbekannt!') 
  200 FORMAT(T16,I4,' Fehler in der Haupteingabedatei') 
  300 FORMAT(T16,I4,' Fehler in der Zusatzeingabedatei') 
      END
